/* ======================================================

  T.O.C. [table of contents]

  01. App text > update
  02. App text > errors
  03. App text > text
  04. App text > tips

====================================================== */

/* ######################################################
  01. Text > update [no need to change]
###################################################### */

$app__settings[ 'local' ][ 'update' ] = '<b>Nieuw in deze versie:</b><ol class="mt-2">' + $app__settings[ 'local' ][ 'update' ] + '</ol><hr>';

/* ######################################################
  02. Text > errors
###################################################### */

/* -----------------------------------------------------

  00 : error > default title of an error-message
  01 : error during initializing the app (server-ini)
  02 : error during reading and parsing the newsfeed
  03 : error during reading and parsing the article
  04 : default error (parent | scroll | etc...)
  05 : error during loading the comments
  06 : error during updating the weather | time
  07 : error at cordova level
  08 : error sending comment or feedback
  09 : error reading local preferences
  10 : error executing a menu function
  11 : error during parsing the statistics
  12 : no internet connection available
  13 : error during parsing the poll
  14 : error during parsing overview items
  15 : error during parsing the discussion
  16 : error while setting a personal item

----------------------------------------------------- */

$app__text[ 'error' ][ 0 ]  = 'Foutmelding';
$app__text[ 'error' ][ 1 ]  = 'Er is iets misgegaan bij het <b>ophalen</b> van de <b>instellingen</b>.';
$app__text[ 'error' ][ 2 ]  = 'Er is iets misgegaan bij het <b>ophalen</b> van het <b>nieuws</b>.';
$app__text[ 'error' ][ 3 ]  = 'Er is iets misgegaan bij het <b>ophalen</b> van het <b>artikel</b>.';
$app__text[ 'error' ][ 4 ]  = 'Er is iets misgegaan met de <b>app</b>.';
$app__text[ 'error' ][ 5 ]  = 'Er is iets misgegaan bij het <b>ophalen</b> van de <b>reacties</b>.';
$app__text[ 'error' ][ 6 ]  = 'Er is iets misgegaan bij het <b>updaten</b> van het weer en de tijd.';
$app__text[ 'error' ][ 7 ]  = 'Er is iets misgegaan bij de <b>communicatie</b> met het <b>toestel</b>.';
$app__text[ 'error' ][ 8 ]  = 'Er is iets misgegaan bij het <b>verzenden</b> van de <b>feedback</b>.';
$app__text[ 'error' ][ 9 ]  = 'Er is iets misgegaan bij de <b>instellingen</b> voor deze <b>app</b>.';
$app__text[ 'error' ][ 10 ] = 'Er is iets misgegaan in het <b>menu</b>.';
$app__text[ 'error' ][ 11 ] = 'Er is iets misgegaan bij het <b>ophalen</b> van de <b>statistieken</b>.';
$app__text[ 'error' ][ 12 ] = 'De <b>internetverbinding</b> is <b>verbroken</b>.';
$app__text[ 'error' ][ 13 ] = 'Er is iets misgegaan bij het <b>ophalen</b> van de <b>poll</b>.';
$app__text[ 'error' ][ 14 ] = 'Er is iets misgegaan bij het <b>maken</b> van het <b>overzicht</b>.';
$app__text[ 'error' ][ 15 ] = 'Er is iets misgegaan bij het <b>aanmaken</b> van de <b>discussie</b>.';
$app__text[ 'error' ][ 16 ] = 'Er is iets misgegaan bij het <b>aanpassen</b> van de <b>persoonlijke</b> voorkeuren.';

/* ######################################################
  03. Text > strings
###################################################### */

/* -----------------------------------------------------

  000 : title of this app
  001 : error > no news-sources available in the feed
  002 : error > news-source is valid, but does not have articles
  003 : read more ellipsis
  004 : modal > close
  005 : show reactions button
  006 : base-address of the app-download > same as 'store' address
  007 : tab 'comments' title
  008 : button 'load' full article
  009 : share app [footer]
  010 : local city | country
  011 : send-button [feedback | comment]
  012 : close the article
  013 : comment-button caption
  014 : give comment on an article
  015 : share the article > caption
  016 : signature when sharing an article [deprecated]
  017 : form > label > nickname [hidden]
  018 : form > placeholder > nickname
  019 : form > label > message [hidden]
  020 : form > placeholder > message
  021 : form > label > mail [hidden]
  022 : form > placeholder > mail
  023 : menu > promote app to friends
  024 : menu > rate the app
  025 : menu > contact developer
  026 : menu > hide images
  027 : try again button, when error
  028 : most recent reactions
  029 : populair articles
  030 : send feedback title
  031 : menu > smaller fonts
  032 : label > like-button
  033 : update : title
  034 : error when no article-content is fetched
  035 : close comments [only comments, not complete article]
  036 : default update-message
  037 : menu > compact lay-out
  038 : menu > nightmode
  039 : share the article > email
  040 : share the article > whatsapp
  041 : comments > options pulldown
  042 : share the article > twitter
  043 : share the article > facebook
  044 : label > reply-button
  045 : label > edit-button
  046 : change namechange > text
  047 : change namechange > limit reached
  048 : close article [placed above comments]
  049 : menu > discussion view
  050 : menu > font type [sans-] serif
  051 : change nickname - placeholder [help]
  052 : update-text [button caption]
  053 : poll explanation
  054 : poll > close button
  055 : populair / pinned prefix
  056 : meta > app version [footer]
  057 : Hide recent reactions [menu]
  058 : Recent reactions [title]
  059 : Populair articles [title]
  060 : meta > update-text [most recent news-update]
  061 : meta > articles-text [amount of articles]
  062 : meta > sources-text [amount of sources]
  063 : comments > option #1 > jump to end of list
  064 : comments > option #2 > users most recent comment
  065 : comments > option #3 > threaded order
  066 : comments > option #4 > chronological order
  067 : comments > option #5 > newest on top
  068 : comments > option #6 > oldest on top
  069 : show archive [button caption]
  070 : meta > comments-text [amount of reactions]
  071 : comments > option #7 > most rated
  072 : comments > option #8 > most recent
  073 : bookmark > button text
  074 : personal > bookmarks title
  075 : personal > bookmarks text
  076 : personal > comments title
  077 : personal > comments text
  078 : pin > 'pin' text (prefix) in the footer | feedback form
  079 : pin > forgot pin #1 > button caption
  080 : pin > forgot pin #2 > email placeholder
  081 : pin > modal title
  082 : pin > screen 1 - explain 1
  083 : pin > screen 1 - explain 2
  084 : pin > screen 2 - requirements
  085 : pin > screen 2 - tip
  086 : pin > screen 2 - re-enter text
  087 : pin > screen 3 - dynamic results
  088 : pin > screen 3 - reminder 1
  089 : pin > screen 3 - reminder 2
  090 : pin > modal footer - buttons caption-dismiss
  091 : pin > modal footer - buttons caption-success
  092 : pin > screen 2 - error-text 1
  093 : pin > screen 2 - error-text 2
  094 : poll > show subtitle for the news-section [after the poll]
  095 : close app with back-key message
  096 : photoswipe > tip to zoom in by doubletap
  097 : pin > forgot pin #3 > extra explain
  098 : pin > forgot pin #4 > ask for support
  099 : interstitial > loading text
  100 : menu > sources copyright
  101 : pin > can not be changed "tip"
  102 : menu > hide all comments
  103 : notice when comments are hidden
  104 : warn > button caption [show more]
  105 : warn > warn-text below icon [warn a message]
  106 : warn > unwarn-text below icon [unwarn a warned message]
  
----------------------------------------------------- */

$app__text[ 'string' ][ 0 ]   = $app__settings[ 'local' ][ 'name' ];
$app__text[ 'string' ][ 1 ]   = 'Er zijn <b>geen nieuwsbronnen</b> aanwezig, probeer het later nog eens.';
$app__text[ 'string' ][ 2 ]   = 'Deze nieuwsbron heeft <b>geen artikelen</b>, probeer het later nog eens.';
$app__text[ 'string' ][ 3 ]   = '(...)';
$app__text[ 'string' ][ 4 ]   = 'Sluit';
$app__text[ 'string' ][ 5 ]   = 'Toon <b>reacties</b>';
$app__text[ 'string' ][ 6 ]   = $app__settings[ 'local' ][ 'url-store' ];
$app__text[ 'string' ][ 7 ]   = '...';
$app__text[ 'string' ][ 8 ]   = 'Lees <b>verder</b>';
$app__text[ 'string' ][ 9 ]   = 'deel deze app';
$app__text[ 'string' ][ 10 ]  = $app__settings[ 'local' ][ 'locality' ];
$app__text[ 'string' ][ 11 ]  = 'Verzend';
$app__text[ 'string' ][ 12 ]  = '<b>Sluit</b> artikel';
$app__text[ 'string' ][ 13 ]  = '<b>Reageer</b> zelf';
$app__text[ 'string' ][ 14 ]  = 'Reageer op het artikel';
$app__text[ 'string' ][ 15 ]  = 'deel';
$app__text[ 'string' ][ 16 ]  = '...';
$app__text[ 'string' ][ 17 ]  = 'Nickname';
$app__text[ 'string' ][ 18 ]  = 'nickname';
$app__text[ 'string' ][ 19 ]  = 'Bericht';
$app__text[ 'string' ][ 20 ]  = '1. reageer met respect :)\n2. meld (warn) misbruik aan @admin\n3. overtreders worden geblokkeerd';
$app__text[ 'string' ][ 21 ]  = 'Email';
$app__text[ 'string' ][ 22 ]  = 'email';
$app__text[ 'string' ][ 23 ]  = 'Deel deze app';
$app__text[ 'string' ][ 24 ]  = 'Beoordeel de app';
$app__text[ 'string' ][ 25 ]  = 'Neem contact op';
$app__text[ 'string' ][ 26 ]  = 'Verberg foto\'s';
$app__text[ 'string' ][ 27 ]  = 'Opnieuw proberen';
$app__text[ 'string' ][ 28 ]  = 'Er zijn nog geen <b>recente reacties</b>, reageer op een bericht om een discussie te beginnen.';
$app__text[ 'string' ][ 29 ]  = 'Er zijn nog geen <b>populaire artikelen</b>, reageer op een bericht om een discussie te beginnen.';
$app__text[ 'string' ][ 30 ]  = 'Geef uw feedback';
$app__text[ 'string' ][ 31 ]  = 'Kleinere letters';
$app__text[ 'string' ][ 32 ]  = 'like';
$app__text[ 'string' ][ 33 ]  = 'Update <small class="text-muted">versie <span></span></small>';
$app__text[ 'string' ][ 34 ]  = 'Er is iets <b>misgegaan.</b> Controleer de <b>internetverbinding</b> en probeer het <b>opnieuw</b>.';
$app__text[ 'string' ][ 35 ]  = 'sluit reacties';
$app__text[ 'string' ][ 36 ]  = '<b class="d-block mb-2">Waardeert u deze app?</b> ';
$app__text[ 'string' ][ 36 ] += 'Laat dan <b class="btn btn-dark btn-brand-dark mx-1 border-0 py-1 px-2" data-action="promote-rate">een review</b> achter ';
$app__text[ 'string' ][ 36 ] += '<i class="zmdi zmdi-hc-lg zmdi-mood d-inline-block cursor-pointer" data-action="promote-rate"></i>';
$app__text[ 'string' ][ 37 ]  = 'Compacte weergave';
$app__text[ 'string' ][ 38 ]  = 'Donker thema';
$app__text[ 'string' ][ 39 ]  = 'Email';
$app__text[ 'string' ][ 40 ]  = 'WhatsApp';
$app__text[ 'string' ][ 41 ]  = 'reactie opties';
$app__text[ 'string' ][ 42 ]  = 'Twitter';
$app__text[ 'string' ][ 43 ]  = 'Facebook';
$app__text[ 'string' ][ 44 ]  = 'reply';
$app__text[ 'string' ][ 45 ]  = 'edit';
$app__text[ 'string' ][ 46 ]  = 'De <b>nickname</b> kan nog <b>{#} keer</b> worden aangepast.<br><br>Klik <b>hieronder</b> op de <b>naam</b> die vanaf nu gebruikt moet worden;';
$app__text[ 'string' ][ 47 ]  = 'De <b>nickname</b> is <b>te vaak</b> aangepast en kan niet meer veranderd worden.<br><br>Neem <b>contact</b> op via het menu voor meer informatie.';
$app__text[ 'string' ][ 48 ]  = 'sluit artikel';
$app__text[ 'string' ][ 49 ]  = 'Reacties onder elkaar';
$app__text[ 'string' ][ 50 ]  = 'Ander lettertype';
$app__text[ 'string' ][ 51 ]  = 'Klik op het slotje...';
$app__text[ 'string' ][ 52 ]  = 'update';
$app__text[ 'string' ][ 53 ]  = 'Geef uw mening om de uitslag te zien.';
$app__text[ 'string' ][ 54 ]  = '<b>Sluit</b> poll';
$app__text[ 'string' ][ 55 ]  = 'populair';
$app__text[ 'string' ][ 56 ]  = 'versie';
$app__text[ 'string' ][ 57 ]  = 'Verberg overzicht';
$app__text[ 'string' ][ 58 ]  = 'Reacties';
$app__text[ 'string' ][ 59 ]  = 'Populair';
$app__text[ 'string' ][ 60 ]  = 'nieuwsupdate {#} uur';
$app__text[ 'string' ][ 61 ]  = 'bronnen';
$app__text[ 'string' ][ 62 ]  = 'artikelen';
$app__text[ 'string' ][ 63 ]  = 'Onderkant lijst';
$app__text[ 'string' ][ 64 ]  = 'Mijn reactie';
$app__text[ 'string' ][ 65 ]  = '<b>Discussie</b>';
$app__text[ 'string' ][ 66 ]  = '<b>Chronologisch</b>';
$app__text[ 'string' ][ 67 ]  = 'Nieuwste eerst';
$app__text[ 'string' ][ 68 ]  = 'Oudste eerst';
$app__text[ 'string' ][ 69 ]  = 'oudere berichten';
$app__text[ 'string' ][ 70 ]  = 'reacties';
$app__text[ 'string' ][ 71 ]  = 'Meest populair';
$app__text[ 'string' ][ 72 ]  = 'Recente reactie';
$app__text[ 'string' ][ 73 ]  = 'favoriet';
$app__text[ 'string' ][ 74 ]  = 'Favorieten';
$app__text[ 'string' ][ 75 ]  = 'Er zijn <b>favorieten</b> (meer) &ndash; druk bij een artikel op <span class="text-muted px-1 d-inline-block"><i class="zmdi zmdi-star mr-1"></i>';
$app__text[ 'string' ][ 75 ] += ' favoriet</span> en de laatste {#} worden hier getoond.';
$app__text[ 'string' ][ 76 ]  = 'Reacties';
$app__text[ 'string' ][ 77 ]  = 'Er zijn geen <b>eigen reacties</b> (meer) &ndash; reageer op een <span class="text-muted px-1 d-inline-block"><i class="zmdi zmdi-comments mr-1"></i>';
$app__text[ 'string' ][ 77 ] += ' artikel</span> en de laatste {#} worden hier getoond.';
$app__text[ 'string' ][ 78 ]  = 'pin';
$app__text[ 'string' ][ 79 ]  = 'Pincode vergeten?';
$app__text[ 'string' ][ 80 ]  = 'Helaas ben ik de pincode vergeten om mijn naam te beschermen...';
$app__text[ 'string' ][ 81 ]  = 'Bescherm uw naam';
$app__text[ 'string' ][ 82 ]  = 'Om te voorkomen dat anderen uw <b>naam</b> kunnen gebruiken, moet u deze beveiligen met een <b>pincode</b>.';
$app__text[ 'string' ][ 83 ]  = 'Heeft u nog <b>nooit</b> een code ingevoerd? Dan kunt u deze nu gewoon zelf <b>verzinnen</b>.';
$app__text[ 'string' ][ 84 ]  = 'Vul hier uw <b>geheime pincode</b> in;';
$app__text[ 'string' ][ 85 ]  = '<b>Tip</b> : geboortejaar.';
$app__text[ 'string' ][ 86 ]  = '<b>Herhaal</b> het getal.';
$app__text[ 'string' ][ 87 ]  = '<b data-namepin="var1">{#}</b> is nu gekoppeld aan;';
$app__text[ 'string' ][ 87 ] += '<br><span class="badge badge-dark d-inline-block mt-2"><b class="lead" data-namepin="var2">{#}</b></span>';
$app__text[ 'string' ][ 88 ]  = '<b>Onthoud dit getal goed.</b>';
$app__text[ 'string' ][ 89 ]  = 'Wanneer u <b>dezelfde naam</b> op een <b>ander toestel</b> wilt gebruiken, moet u <b>deze code</b> weer invoeren.';
$app__text[ 'string' ][ 90 ]  = '<span>Annuleer</span><span>Okay</span>';
$app__text[ 'string' ][ 91 ]  = '<span>Okay</span><span>Bewaar</span>';
$app__text[ 'string' ][ 92 ]  = 'Minimaal <b>2</b> cijfers.';
$app__text[ 'string' ][ 93 ]  = 'Getal klopt <b>niet</b>.';
$app__text[ 'string' ][ 94 ]  = '&ndash; nieuwsoverzicht &ndash;';
$app__text[ 'string' ][ 95 ]  = 'Druk nogmaals om de app te sluiten.';
$app__text[ 'string' ][ 96 ]  = 'Tik 2x om te vergroten.';
$app__text[ 'string' ][ 97 ]  = 'Heeft u al wel eerder een code gebruikt, maar bent u die vergeten?';
$app__text[ 'string' ][ 98 ]  = 'Neem dan contact op.';
$app__text[ 'string' ][ 99 ]  = '<b>ADVERTENTIE LADEN</b><br>- bedankt voor uw begrip -';
$app__text[ 'string' ][ 100 ] = 'Nieuwsbronnen';
$app__text[ 'string' ][ 101 ] = '(kan niet aangepast worden)';
$app__text[ 'string' ][ 102 ] = 'Verberg reacties';
$app__text[ 'string' ][ 103 ] = '<b>reacties</b> zijn verborgen via het menu';
$app__text[ 'string' ][ 104 ] = '<b>verborgen</b> - toon reactie';
$app__text[ 'string' ][ 105 ] = 'warn';
$app__text[ 'string' ][ 106 ] = 'okay';

/* ######################################################
  04. Text > tips
###################################################### */

/* -----------------------------------------------------

  00 : prefix of every tip
  01 : explain the menu
  02 : explain the menu
  03 : jump to a source
  04 : local time and weather
  05 : last update time
  06 : personal menu

----------------------------------------------------- */

$app__text[ 'tip' ][ 0 ]  = '<b>TIP</b> :';
$app__text[ 'tip' ][ 1 ]  = 'open of sluit een artikel';
$app__text[ 'tip' ][ 2 ]  = 'het menu met instellingen';
$app__text[ 'tip' ][ 3 ]  = 'open snel een nieuwsbron';
$app__text[ 'tip' ][ 4 ]  = 'de lokale tijd en het weer';
$app__text[ 'tip' ][ 5 ]  = 'update het nieuwsoverzicht';
$app__text[ 'tip' ][ 6 ]  = 'persoonlijke favorieten en reacties';

/* ######################################################
  05. Text > weather
###################################################### */

$app__text[ 'weather' ]['000'] = '(onbekend weertype)';
$app__text[ 'weather' ]['01d'] = $app__text[ 'weather' ]['01n'] = 'onbewolkt';
$app__text[ 'weather' ]['02d'] = $app__text[ 'weather' ]['02n'] = 'licht bewolkt';
$app__text[ 'weather' ]['03d'] = $app__text[ 'weather' ]['03n'] = 'bewolkt';
$app__text[ 'weather' ]['04d'] = $app__text[ 'weather' ]['04n'] = 'zwaar bewolkt';
$app__text[ 'weather' ]['09d'] = $app__text[ 'weather' ]['09n'] = 'plaatselijk regen';
$app__text[ 'weather' ]['10d'] = $app__text[ 'weather' ]['10n'] = 'regen';
$app__text[ 'weather' ]['11d'] = $app__text[ 'weather' ]['11n'] = 'onweer';
$app__text[ 'weather' ]['13d'] = $app__text[ 'weather' ]['13n'] = 'sneeuw';
$app__text[ 'weather' ]['50d'] = $app__text[ 'weather' ]['50n'] = 'mist';

$app__text[ 'weather' ][ 0 ] = 'Bewolking';
$app__text[ 'weather' ][ 1 ] = 'Windkracht';