/* ======================================================

  T.O.C. [table of contents]

  01. Fire the article buttons
  02. Load the article
  03. Parse (show) the article
  04. Parse the image
  05. Enlarge | close image
  06. Share an article
  07. Render 'smart' article button
  08. Fire 'smart' article button

====================================================== */

/* Set some variables */

var $app__image_fullscreen = '';

/* Ref. https://photoswipe.com/documentation/options.html */

var $app__pswp_title, $app__pswp_source_file, $app__pswp_gallery, $app__pswp_data, $app__pswp_entry, $app__pswp_width, $app__pswp_height;

var $app__pswp_object = $( '#pswp__modal' )[ 0 ], $app__pswp_options = {
      
  barsSize: { top: 44, bottom: 44 /* auto */ },
  index: 0,
  bgOpacity: 0.85,
  showHideOpacity: true,
  escKey: false,
  timeToIdle: 4000,
  spacing: 0,
  allowPanToNext: false,
  loop: false,
  pinchToClose: true,
  closeEl:true,
  captionEl: true,
  fullscreenEl: false,
  zoomEl: true,
  shareEl: false,
  counterEl: false,
  arrowEl: false,
  preloaderEl: true,
  history: false

};

;(function ( $ ) { try {

/* ######################################################
  01. Enable the 'read more' | close buttons
###################################################### */

/* -----------------------------------------------------
  Open the article
----------------------------------------------------- */

$( 'body' ).on( 'click', '[data-action=open]:not(.disabled)', function( $app__event ) {

  try {

    $app__event.preventDefault();

    $( this ).addClass( 'disabled' );

    var $app__article_src = $( this ).closest( 'ol' ).data( 'src' );
    var $app__scroll_to = $app__interstitial_entry = $( this ).closest( 'li' );
    var $app__article_guid = $app__scroll_to.data( 'guid' );

/* Check if comments are already loaded -> if not, auto-load with article [when allowed by server-setting] */

    var $app__load_comments = $( this ).closest( 'div' ).find( 'article .comments' ).length;
    
    $app__load_comments = $app__load_comments === 0 ? 1 : 0;

      if ( $app__readonly === 1 ) {

        $app__load_comments = 0;

      }

    $( this ).prev( '[data-action=comments], [data-action=comment]' ).addClass( 'invisible' );
    app__loading_button( $( this ) );

/* Check if H3 is out of sight */

    var $app__scroll_position = $app__scroll_to.offset().top - $( window ).scrollTop();
    var $app__scroll_delay = $app__scroll_position < $( '.navbar' ).outerHeight() ? 500 : 0;

      if ( $app__scroll_delay !== 0 ) {

        $( 'html, body' ).animate( {

          scrollTop: Math.floor( $app__scroll_to.offset().top - $( '.navbar' ).outerHeight() - 10 )

        }, $app__scroll_delay );

      }

/* Show article, with or without delay */

      setTimeout( function() {
        
          app__article_load( $app__article_src, $app__article_guid, $app__load_comments );

      }, $app__scroll_delay );

  } catch( $app__error ) {

    app__error( 'app__article#01A', 3, $app__error );

  }

});

/* -----------------------------------------------------
  Close the article
----------------------------------------------------- */

$( 'body' ).on( 'click', '[data-action=close]', function( $app__event ) {

  try {

    $app__event.preventDefault();

/* Check if H3 is out of sight */

    var $app__scroll_to = $( this ).closest( 'li' );
    var $app__scroll_position = $app__scroll_to.offset().top - $( window ).scrollTop();
    var $app__scroll_delay = $app__scroll_position < $( '.navbar' ).outerHeight() ? 500 : 0;
    var $app__close_button = $app__scroll_to.find( 'h3[data-toggle]' );

      if ( $app__scroll_delay != 0 ) {

        $( 'html, body' ).animate( {

          scrollTop: Math.floor( $app__scroll_to.offset().top - $( '.navbar' ).outerHeight() - 10 )

        }, $app__scroll_delay );

      }

/* Close article, with or without delay */

      setTimeout( function() {

        $app__close_button.trigger( 'click' );

      }, $app__scroll_delay );

  } catch( $app__error ) {

    app__error( 'app__article#01B', 3, $app__error );

  }

});

/* ######################################################
  02. Load the article
###################################################### */

function app__article_load( $app__article_src, $app__article_guid, $app__load_comments ) {

  try {

    var $app__api = 'news';
    $app__url = $app__settings[ 'local' ][ 'api' ] + $app__api + '&src=' + parseInt( $app__article_src ) + '&url=' + $app__article_guid + '&comments=' + $app__load_comments;

    app__cmd( 'app__article : loading > ' + $app__url );

    $.ajax({

      method: 'get',
      url: $app__url,
      cache: false,
      dataType: 'text',
      complete: function() {

/* 2DO */

      },
      success: function( $app__response, $app__status, $app__xhr ) {

        app__cmd( 'app__article : article loaded', 1 );

        var $app__article = $app__response;

        if ( $app__article.length < 5 || $app__article == '' ) {

          $app__article = '<div class="shadow alert alert-warning my-4">' + $app__text[ 'string' ][ 34 ] + '</div>';

        } else {

          app__list_set( 'articles', $app__article_guid );

        }
        
        var $app__interstitial_delay = $app__interstitial_show === 1 ? 1000 : 0;
        
        setTimeout( function() {

          app__article_parse( $app__article_src, $app__article_guid, $app__load_comments, $app__article );

        }, $app__interstitial_delay );

      },
      error: function( $app__xhr, $app__status, $app__error ) {

        app__error( 'app__article#02A', 3, JSON.stringify( $app__xhr ) );

      }

    });

  } catch( $app__error ) {

    app__error( 'app__article#02B', 3, $app__error );

  }

}

/* ######################################################
  03. Parse (show) the article
###################################################### */

function app__article_parse( $app__article_src, $app__article_guid, $app__load_comments, $app__article_text ) {

  try {

    var $app__article_text = $app__article_text || '';
    var $app__article = $( 'ol[data-src="' + $app__article_src + '"] li[data-guid="' + $app__article_guid + '"]' );

/* Fetch the article-image */

    try {

      var $app__image_src = $app__settings[ 'user' ][ 'hide_images' ] === true ? false : app__image_parse( $app__article_text );

/* Remove the image from the article-source */

      var $app__article_text = $app__article_text.replace( /<div class="img-container"[^>]*?>[\s\S]*?<\/div>/gi, '' );
      
/* Add the image, in it's own container */
      
      if ( typeof $app__image_src !== 'undefined' && $app__image_src !== false && $app__image_src != '' ) {

        $app__image_title = '';

        if ( $app__settings[ 'local' ][ 'debug' ] === true ) {

          $app__image_title = $app__image_src;
          $app__image_title = ( $app__image_api_xl === '-1' ? '[ local ] ' : '[ remote ] ' ) + $app__image_title;
          $app__image_title = ' title="' + $app__image_title + '"';

        }

        var $app__article_img = '<figure data-image="' + $app__image_src + '"' + $app__image_title + ' class="featured loading rounded my-4 w-100"></figure>';

        $app__article_text = $app__article_img + $app__article_text;

/* Pre-cache the image, remove gizmo afterwards [prevent memory leak] */

          $( '<img/>' ).attr( 'src', $app__image_src ).on( 'load', function() {

            $( this ).remove();

            $app__figure = $( 'figure[data-image="' + $app__image_src + '"]' );

            $app__figure.
              removeClass( 'loading' ).
              css( {'background-image' : 'url("' + $app__image_src + '")'} ).
              addClass( 'loaded' );

          });

          setTimeout( function() {

            $app__figure.addClass( 'fired' );

            setTimeout( function() {

              $app__figure.removeClass( 'fired' );

            }, 3000 );

          }, 1500 );

      }

    } catch ( $app__error ) {

      $app__article.find( 'figure' ).remove();

    }

/* 1#4 > show the article */

      $app__article.addClass( 'read' ).find( '.article' ).html( $app__article_text );

/* 2#4 > adjust close-, comments- and read-more buttons */

      $app__article.find( '[data-action=close].close-down' ).remove().end().find( '[data-action=close].close-top' ).removeClass( 'd-none' ).addClass( 'd-inline-block' );

      app__buttons_toggle( $app__article_src, $app__article_guid, 1 );

/* 3#4 > parse comments [when needed] */

      if ( $app__load_comments === 1 ) {

        $app__article.find( 'ol.comments' ).insertAfter( $app__article.find( '.article') );
        
        app__comments_parse( $app__article_src, $app__article_guid );

      } else {

        if ( $app__article.find( '[data-action=comments-bottom]' ).length ) {
      
          app__article_button( $app__article, 3 );
  
        }
  
      }

/* 4#4 > show interstitial when article is loaded */

      if ( $app__interstitial_show === 1 ) {

        try {

          $( '#app__interstitial' ).addClass( 'fired' );

            $( 'html, body' ).animate( {

              scrollTop: Math.floor( $app__interstitial_entry.offset().top - $( '.navbar' ).outerHeight() - 10 )

            }, 0, function() {

              $( 'body' ).addClass( 'no-flow' );

            } );

          $app__interstitial_show = -1;
          app__user_set( 'interstitial', '' + $app__interstitial );

          setTimeout( function() {

            if ( typeof AdMob !== 'undefined' ) {

              AdMob.showInterstitial();

            }

            setTimeout( function() {

              $( '#app__interstitial' ).removeClass( 'fired' );
              $( 'body' ).removeClass( 'no-flow' );

            }, 1000 );

          }, 2500 );

      } catch ( $app__error ) {

        app__error( 'app__article#03A', 3, $app__error );
    
      }
    
    }

  } catch ( $app__error ) {

    app__error( 'app__article#03B', 3, $app__error );

  }

}

/* ######################################################
  04. Parse the image
###################################################### */

function app__image_parse( $app__article_text ) {

  try {
    
    if ( $app__article_text.indexOf( 'img-responsive' ) !== -1 ) {

      return $( $app__article_text ).find( '.img-responsive' ).eq( 0 ).attr( 'src' );
      
    } else {

      return '';

    }

  } catch( $app__error ) {

    app__error( 'app__article#04', 3, $app__error );

  }

}

/* ######################################################
  05. Actions binded to the image
###################################################### */

/* -----------------------------------------------------
  Enlarge the image
----------------------------------------------------- */

$( 'body' ).on( 'click', 'article figure.featured, article img', function() {

  try {

/*

    $( '.modal' ).
      css( {'background-image': 'url("' + $( this ).attr( 'data-image' ) + '")'} ).
      addClass( 'modal-image featured' ).
      modal();
 
*/

    $app__image_fullscreen = $( this );
    $app__image_fullscreen.addClass( 'disabled' );
    $app__pswp_source_file = typeof $( this ).data( 'image' ) !== 'undefined' ? $( this ).attr( 'data-image' ) : $( this ).attr( 'src' );
    $app__pswp_title = app__format_string( $app__settings[ 'local' ][ 'name' ], 1 );

    var $app__pswp_title_tmp = $( this ).parent().next( 'p' ).find( '[data-title=app__pswp_main]' ).html();

      if ( $app__pswp_title_tmp !== '' && $app__pswp_title_tmp !== undefined ) {

        $app__pswp_title = app__format_string( $app__pswp_title_tmp, 1 );
        
        $app__pswp_title_tmp = $( this ).parent().next( 'p' ).find( '[data-title=app__pswp_sub]' ).html();

        if ( $app__pswp_title_tmp !== '' && $app__pswp_title_tmp !== undefined ) {

          $app__pswp_title = $app__pswp_title + '<br>' + app__format_string( $app__pswp_title_tmp, 1 );

        }

      } else {
        
        $app__pswp_title_tmp = $( this ).closest( 'li[data-guid]' ).find( 'h3[data-toggle]' ).html();

        if ( $app__pswp_title_tmp !== '' && $app__pswp_title_tmp !== undefined ) {

          $app__pswp_title = app__format_string( $app__pswp_title_tmp, 3 );

        }

      }

    $( '<img/>' ).attr( 'src', $app__pswp_source_file ).on( 'load', function() {
    
      $app__pswp_width = this.width;
      $app__pswp_height = this.height;

/* Allow image to always fit screen - even when smaller than the screen itself > make it 90% so the x-axis padding is filled op (.9 scale) */

      if ( $app__pswp_width < $app__win_w ) {

        $app__pswp_height = $app__pswp_height * ( $app__win_w / $app__pswp_width );
        $app__pswp_width = $app__win_w;

        $app__pswp_height = Math.round( $app__pswp_height / 100 * 89 );
        $app__pswp_width = Math.round( $app__pswp_width / 100 * 89 );

      }
    
      $( this ).remove();
    
/* Initialize (reset) the image array */
    
      $app__pswp_data = [];
    
/* Create the new entry  */
    
      $app__pswp_entry = {
      
        src: $app__pswp_source_file,
        w: $app__pswp_width,
        h: $app__pswp_height,
        title: $app__pswp_title
      
      };
      
      $app__pswp_data.push( $app__pswp_entry );
    
/* Fire the modal */
    
      $app__pswp_gallery = new PhotoSwipe( $app__pswp_object, PhotoSwipeUI_Default, $app__pswp_data, $app__pswp_options );
      
      $( 'body' ).addClass( 'pswp-open' );
      $( '#pswp__modal .pswp__counter' ).removeClass( 'opacity-0' );
      app__photoswipe_fire();
      $app__pswp_gallery.init();

    });

  } catch( $app__error ) {

    app__error( 'app__article#05A', 3, $app__error );

  }

});

/* -----------------------------------------------------
  Bind some actions
----------------------------------------------------- */

function app__photoswipe_fire() {

  try {

    $app__pswp_gallery.listen( 'destroy', function() {
            
      $( 'body' ).removeClass( 'pswp-open' );
      $app__image_fullscreen.removeClass( 'disabled' );

    });

    $app__pswp_gallery.listen( 'zoomGestureEnded', function() {

      setTimeout( function() {

/* Show help-text when viewing at 100% or smaller */

        if ( $app__pswp_gallery.getZoomLevel() < 1 ) {

          $( '#pswp__modal .pswp__counter' ).removeClass( 'opacity-0' );

/* Hide help-text when zoomed in */

        } else {

          $( '#pswp__modal .pswp__counter' ).addClass( 'opacity-0' );

        }

      }, 750 );
    
    });

    $app__pswp_gallery.listen( 'pointerUp', function() {
      
      setTimeout( function() {

        if ( $app__pswp_gallery.getZoomLevel() < 1 ) {

          $( '#pswp__modal .pswp__counter' ).removeClass( 'opacity-0' );

        } else {

          $( '#pswp__modal .pswp__counter' ).addClass( 'opacity-0' );

        }

      }, 750 );

    });

  } catch( $app__error ) {

    app__error( 'app__article#05B', 3, $app__error );

  }

}

/* Close the image modal [with every element] */

/*

  $( 'body' ).on( 'click', '.modal-image.featured', function() {

    $( '.modal' ).modal( 'hide' );

  })

*/

/* ######################################################
  06. Share an article
###################################################### */

$( 'body' ).on( 'click', '[data-action^=share-]', function( $app__event ) {

  try {

    $app__event.preventDefault();

    $( this ).blur();

    var $app__share_link = $( this ).closest( 'li' ).data( 'link' );
    var $app__share_body = $( this ).closest( 'li' ).find( '.article' ).text();
    var $app__share_subject = app__format_string( $( this ).closest( 'li' ).find( 'h3' ).html(), 3 );

      if ( $app__share_subject.length < 3 ) {

        $app__share_subject = app__format_string( $app__text[ 'string' ][ 0 ] );

      }
    
    var $app__share_meta = '?app__share_link=' + encodeURIComponent( $app__share_link ) + '&app__share_subject=' + encodeURIComponent( $app__share_subject );

/* Decide how to share */

    $app__share_type = $( this ).attr( 'data-action' );

      switch ( $app__share_type ) {

        case 'share-email':

          // app__mail( $app__share_subject, $app__share_body );

            if ( $app__share_body.length > 200 ) {

              $app__share_body = $.trim( $app__share_body.substr( 0, 200 ) );

              if ( $app__share_body.indexOf( ' ' ) !== -1 ) {

                $app__share_body = $app__share_body.substr( 0, $app__share_body.lastIndexOf( ' ' ) );

              }

              $app__share_body += ' (...)';

            }

          app__browse( $app__settings[ 'local' ][ 'url-email' ] + $app__share_meta + '&app__share_body=' + $app__share_body );

        break;

        case 'share-whatsapp':

          app__browse( $app__settings[ 'local' ][ 'url-whatsapp' ] + $app__share_meta );

        break;

        case 'share-twitter':

          app__browse( $app__settings[ 'local' ][ 'url-twitter' ] + $app__share_meta );

        break;

        case 'share-facebook':

          app__browse( $app__settings[ 'local' ][ 'url-facebook' ] + $app__share_meta );

        break;

      }

  } catch( $app__error ) {

    app__error( 'app__article#06', 3, $app__error );

  }

});

/* ######################################################
  07. Smart button - render
###################################################### */

window.app__article_button = function app__article_button( $app__article, $app__article_intension ) {

  try {

    switch ( $app__article_intension ) {

/* Close article trigger */

      case 1:
      case 3:
        $app__article.find( '.btn-smart' ).attr( 'data-smart', $app__article_intension ).removeClass( 'disabled' ).css( { 'opacity': 1 } ).find( 'i' ).removeClass( 'zmdi-eye' ).addClass( 'zmdi-close' ).next( 'span' ).text( app__format_string( $app__text[ 'string' ][ 12 ] ).toLowerCase() );
      break;

/* Open article trigger */

      case 2:
        $app__article.find( '.btn-smart' ).attr( 'data-smart', $app__article_intension ).find( 'i' ).removeClass( 'zmdi-close' ).addClass( 'zmdi-eye' ).next( 'span' ).text( app__format_string( $app__text[ 'string' ][ 8 ] ).toLowerCase() );
      break;

    }

  } catch( $app__error ) {

    app__error( 'app__article#07', 3, $app__error );

  }

}

/* ######################################################
  08. Smart button - trigger
###################################################### */

$( 'body' ).on( 'click', '[data-action=smart-button]:not( .disabled )', function( $app__event ) {

  try {

    $app__event.preventDefault();

    var $app__article_intension = parseInt( $( this ).attr( 'data-smart' ) );

    switch ( $app__article_intension ) {

/* Close article */

      case 1:
      case 3:
        $( this ).closest( 'li' ).find( 'button[data-action=close]' ).trigger( 'click' );
      break;

/* Open article */

      case 2:
        $( this ).addClass( 'disabled' ).css( { 'opacity': .5 } ).closest( 'li' ).find( 'button[data-action=open]' ).trigger( 'click' );
      break;

    }
  
  } catch( $app__error ) {

    app__error( 'app__article#08', 3, $app__error );

  }

} );

/* -----------------------------------------------------
  Catch me if you can
----------------------------------------------------- */

  app__cmd( 'app__article : script loaded' );

} catch ( $app__error ) {

  app__error( 'app__article#00', 3, $app__error.message );

} }(jQuery));