/* ======================================================

  T.O.C. [table of contents]

  01. Fire the comments buttons
  02. Load the comments
  03. Parse | render [extend | fire] the comments
  04. Like a comment
  05. Comment [menu] actions
  06. Order the comments [thread]
  07. Order the comments [time]
  08. Scroll to a mentioned-comment
  09. Hide a comment
  
====================================================== */

var $app__feedback_src, $app__feedback_guid, $app__feedback_button = '';
var $app__reply_length = 150;
var $app__comment_callback = -1; /* -1 : no comment callback at all | 1 : user has left a comment | (string#id) : jump to recent comment */

;(function ( $ ) { try {

/* ######################################################
  01. Enable the 'comments' buttons
###################################################### */

/* -----------------------------------------------------
  Load all comments
----------------------------------------------------- */

$( 'body' ).on( 'click', '[data-action=comments]:not(.disabled)', function( $app__event ) {

  try {

    $app__event.preventDefault();

    $( this ).addClass( 'disabled' );
    
    var $app__comments_src = $( this ).closest( 'ol' ).data( 'src' );
    var $app__comments_guid = $( this ).closest( 'li' ).data( 'guid' );

    $( this ).next( '[data-action=open]' ).addClass( 'invisible' );
    app__loading_button( $( this ) );
    app__comments_load( $app__comments_src, $app__comments_guid );

  } catch( $app__error ) {

    app__error( 'app__comments#01A', 5, $app__error );

  }

});

/* -----------------------------------------------------
  Write a comment
----------------------------------------------------- */

$( 'body' ).on( 'click', '[data-action=comment]:not(.disabled)', function( $app__event ) {

  try {

    $app__event.preventDefault();

    $app__feedback_button = $( this );
    $app__feedback_button.addClass( 'disabled' );

/* Save news-src, article-id [needed at the back-end] and subject, image [show in modal-title] */

    $app__feedback_src = $( this ).closest( 'ol' ).data( 'src' );
    $app__feedback_guid = $( this ).closest( 'li' ).data( 'guid' );

    var $app__feedback_image = app__thumbnail_get( $( this ).closest( 'li' ) );
    var $app__figure = '<figure class="position-absolute rounded thumbnail" style="background-image: url(' + $app__feedback_image + ');"></figure>';
    var $app__feedback_item = app__format_string( $( this ).closest( 'li[data-guid]' ).find( 'h3[data-toggle]' ).html(), 3 );

      if ( $app__feedback_item.length < 3 ) {

        $app__feedback_item = app__format_string( $app__text[ 'string' ][ 0 ] );

      }

    $( 'form.form-feedback #file' ).val( $app__feedback_src + '/' + $app__feedback_guid );
    $( 'form.form-feedback #item' ).val( $app__feedback_item );
    $( 'form.form-feedback #pin' ).val( $app__settings[ 'user' ][ 'pin' ] );

/* Reset reply#id when it's not a reply */

      if ( $( 'form.form-feedback #reply' ).val() === '' ) {

        $( 'form.form-feedback #reply' ).val( -1 );    
        $( 'form.form-feedback #level' ).val( 0 );

      }

/* Create timestamp for new feedback-entries */

      if ( $( 'form.form-feedback #time' ).val() === '' ) {

        $app__feedback_id = Date.now();
        $( 'form.form-feedback #time' ).val( $app__feedback_id );

      }

    $app__feedback_id = $( 'form.form-feedback #time' ).val();

/* Fire the modal */

    $( '.modal' ).
      addClass( 'modal-feedback comment' ).
      find( '.modal-title' ).
      html( $app__feedback_item ).
      prepend( $app__feedback_image !== -1 ? $app__figure : '' ).
      addClass( ( $app__feedback_image !== -1 ? 'thumb' : '' ) ).
      end().modal();

  } catch( $app__error ) {

    app__error( 'app__comments#01B', 5, $app__error );

  }

});

/* -----------------------------------------------------
  Like a comment
----------------------------------------------------- */

$( 'body' ).on( 'click', '.user-actions > .badge', function( $app__event ) {

  $app__event.preventDefault();

  $( this ).next( '[data-action=like]:not(.disabled)' ).trigger( 'click' );

});

$( 'body' ).on( 'click', '[data-action=like]:not(.disabled)', function( $app__event ) {

  try {

    $app__event.preventDefault();
    
    var $app__like_el = $( this );
    var $app__like_meta = $app__like_el.closest( 'h4' );
    var $app__like_id = $app__like_meta.data( 'id' );
    var $app__like_src = $app__like_el.closest( '[id*=app__source_]' ).data( 'src' );
    var $app__like_guid = $app__like_el.closest( 'li[data-guid]' ).data( 'guid' );

    $app__like_el.addClass( 'disabled' );
    app__comment_like( $app__like_id, $app__like_src, $app__like_guid );

  } catch( $app__error ) {

    app__error( 'app__comments#01C', 5, $app__error );

  }

});

/* -----------------------------------------------------
  Reply on a comment
----------------------------------------------------- */

$( 'body' ).on( 'click', '[data-action=reply]', function( $app__event ) {

  try {

    $app__event.preventDefault();

    var $app__comment_meta = $( this ).closest( 'h4' );
    var $app__comment_id = $app__comment_meta.data( 'id' );
    var $app__comment_level = $app__comment_meta.data( 'level' );
    var $app__comment_name = app__format_string( $app__comment_meta.find( 'span.user-name' ).html(), 3 );

      if ( $app__comment_name !== '' && $app__comment_name.length > 1 ) {

        $app__comment_name = $app__comment_name.toUpperCase().trim();

      } else {

        $app__comment_name = '...';

      }

    $( this ).closest( 'article' ).next( '.btn[data-action=comment]' ).trigger( 'click' );
    $( 'form.form-feedback #reply' ).val( $app__comment_id );
    $( 'form.form-feedback #level' ).val( parseInt( $app__comment_level ) + 1 );
    $( 'form.form-feedback #text' ).val( '@' + $app__comment_name + ' : ' ).focus();

  } catch( $app__error ) {

    app__error( 'app__comments#01D', 5, $app__error );

  }

});

/* -----------------------------------------------------
  Edit a comment
----------------------------------------------------- */

$( 'body' ).on( 'click', '[data-action=edit]', function( $app__event ) {

  try {

    $app__event.preventDefault();
    
    var $app__comment_meta = $( this ).closest( 'h4' );
    var $app__comment_id = $app__comment_meta.data( 'id' );
    var $app__feedback_text = $app__comment_meta.next( 'p' ).html();

      if ( $app__feedback_text && typeof $app__feedback_text === 'string' ) {

/* Convert breaks | remove quotes | remove (admin-) tags | convert brackets and &-character */

        $app__feedback_text = $app__feedback_text.replace( /<br\s*[\/]?>/gi, '\n' );
        $app__feedback_text = $app__feedback_text.replace( /<i class="quote".*>.*?<\/i>/ig, '' );
        $app__feedback_text = $app__feedback_text.replace( /<\/?\w(?:[^"'>]|"[^"]*"|'[^']*')*>/gmi, '' );
        $app__feedback_text = $app__feedback_text.replace( '&gt;','>' ).replace( '&lt;', '<' ).replace( '&amp;', '&' );

      } else {

        $app__feedback_text = '...';

      }

    var $app__reply_id = $app__comment_meta.data( 'reply' );

      if ( $app__reply_id !== '-1' && $app__reply_id !== 'undefined' && $app__reply_id !== '' && $app__reply_id !== null ) {

        $( 'form.form-feedback #reply' ).val( $app__reply_id );    
        $( 'form.form-feedback #level' ).val( 1 );    

      }

    $( 'form.form-feedback #time' ).val( $app__comment_id );

    $( this ).closest( 'article' ).next( '.btn[data-action=comment]' ).trigger( 'click' );

    $( 'form.form-feedback #text' ).val( $app__feedback_text.trim() );

  } catch( $app__error ) {

    app__error( 'app__comments#01E', 5, $app__error );

  }

});

/* -----------------------------------------------------
  Hide a comment
----------------------------------------------------- */

$( 'body' ).on( 'click', '[data-action=hide]:not(.disabled)', function( $app__event ) {

  try {

    $app__event.preventDefault();
    
    var $app__hide_el = $( this );
    var $app__hide_meta = $app__hide_el.closest( 'h4' );
    var $app__hide_id = $app__hide_meta.data( 'id' );
    var $app__hide_src = $app__hide_el.closest( '[id*=app__source_]' ).data( 'src' );
    var $app__hide_guid = $app__hide_el.closest( 'li[data-guid]' ).data( 'guid' );
    var $app__hide_item = app__format_string( $app__hide_el.closest( 'li[data-guid]' ).find( 'h3[data-toggle]' ).html(), 3 );

    $app__hide_el.addClass( 'disabled' );

/*

    setTimeout( function() {

      $app__hide_el.removeClass( 'disabled' );

    }, 1000 );

    if ( !$app__hide_el.hasClass( 'fired' ) ) {

      $app__hide_el.addClass( 'fired' );
      var $app__hide_score = 1;

    } else {

      $app__hide_el.removeClass( 'fired' );
      var $app__hide_score = -1;

    }

*/

    app__comment_hide( $app__hide_id, $app__hide_src, $app__hide_guid, $app__hide_item /* , $app__hide_score */ );

  } catch( $app__error ) {

    app__error( 'app__comments#01F', 5, $app__error );

  }

});

/* ######################################################
  02. Load the comments
###################################################### */

window.app__comments_load = function app__comments_load( $app__comments_src, $app__comments_guid ) {

  try {

    var $app__api = 'comments';
    $app__url = $app__settings[ 'local' ][ 'api' ] + $app__api + '&src=' + parseInt( $app__comments_src ) + '&url=' + $app__comments_guid;

    app__cmd( 'app__comments : loading > ' + $app__url );

    $.ajax({

      method: 'get',
      url: $app__url,
      cache: false,
      dataType: 'text',
      complete: function() {

/* 2DO */

      },
      success: function( $app__response, $app_status, $app__xhr ) {

        app__cmd( 'app__comments : comments loaded', 1 );

        var $app__comments = $app__response;

        if ( $app__comments.length < 5 || $app__comments == '' ) {

          $app__comments = '<div class="shadow alert alert-warning my-4">' + $app__text[ 'string' ][ 34 ] + '</div>';
          $( 'ol[data-src="' + $app__comments_src + '"] li[data-guid="' + $app__comments_guid + '"] article .article' ).after( $app__comments );

        } else {

/* Populate comments */

          $app__comments = '<ol class="comments d-none">' + $app__comments + '</ol><small class="text-secondary link-secondary cursor-pointer ml-1 mt-3 mb-2 d-none close-down" data-action="close"><i class="zmdi zmdi-close mr-2 d-inline-block"></i>' + $app__text[ 'string' ][ 35 ] + '</small>';

/* Place comments */

          $( 'ol[data-src="' + $app__comments_src + '"] li[data-guid="' + $app__comments_guid + '"] article .article' ).after( $app__comments );

/* Extend comments with functions and features */

          app__comments_parse( $app__comments_src, $app__comments_guid );
          app__buttons_toggle( $app__comments_src, $app__comments_guid, 2 );

        }

      },
      error: function( $app__xhr, $app__status, $app__error ) {

        app__error( 'app__comments#02A', 5, JSON.stringify( $app__xhr ) );

      }

    });

  } catch( $app__error ) {

    app__error( 'app__comments#02B', 5, $app__error );

  }

}

/* ######################################################
  03. Render each comment with buttons and meta-data
###################################################### */

window.app__comments_parse = function app__comments_parse( $app__comments_src, $app__comments_guid ) {

  try {

/* Setup some vars */

    var $app__comments_article = 'ol[data-src="' + $app__comments_src + '"] li[data-guid="' + $app__comments_guid + '"] article';
    var $app__comments_index = $app__reply_level = $app__reply_level_tmp = 0;
    var $app__comments_actions = $app__comments_self = $app__comments_starred = '';
    var $app__comments_class = 'mt-4';

/* Update the ammount of comments for every thread the user has commented in */

    var $app__commented_gui = $( $app__comments_article ).closest( 'li' ).removeClass( 'comments-new' ).data( 'guid' );
    var $app__commented = app__in_array( $app__settings[ 'list' ][ 'commented' ], $app__commented_gui );

      if ( $app__commented !== -1 ) {

        app__list_set( 'commented',  $app__commented_gui + '|' + $( $app__comments_article + ' .comments' ).find( 'li' ).length );

      }

/* Parse every comment for this article */

    var $app__comment_starred_id = -1;
    var $app__comment_starred_treshold = $app__comment_starred;

    $( $app__comments_article + ' .comments li' ).each( function() {

      $app__comments_index++;
      $( this ).attr( 'data-index', $app__comments_index );

      var $app__comment_meta = $( this ).find( 'h4' );
      var $app__comment_id = $app__comment_meta.data( 'id' );
      var $app__comment_likes = $app__comment_meta.data( 'likes' );
      var $app__comment_like_class = 'thumb-up cursor-pointer';
      var $app__comment_hide_class = 'close cursor-pointer ml-2';
      var $app__comment_feedback_class = 'mail-reply cursor-pointer';

/* Get the most populair comment for this thread */

        if ( ( $app__comment_likes >= $app__comment_starred_treshold ) && $app__comment_starred !== -1 ) {

          $app__comment_starred_treshold = $app__comment_likes;
          $app__comment_starred_id = $app__comment_id;

        }

        if ( $.inArray( $app__comment_id, $app__settings[ 'list' ][ 'likes' ] ) !== -1 ) {

          $app__comment_like_class += ' disabled';

        }

/* Check if comment is set to be hidden */

      var $app__comment_hides = $app__comment_meta.data( 'hides' );
      var $app__comment_hides_treshold = $app__comment_hide;

        if ( $app__comment_hides >= $app__comment_hides_treshold && $app__comment_hide !== -1 || $app__comment_meta.hasClass( 'moderated hide' ) ) {

          $( 'p', this ).before( '<button class="btn btn-sm btn-hide mb-3" data-hide-auto="' + $app__comment_hide_auto + '">' +
          '<i class="zmdi zmdi-hc-lg zmdi-eye-off mr-2"></i>' +
          $app__text[ 'string' ][ 104 ] +
          '</button>' );

          if ( !$app__comment_meta.hasClass( 'moderated' ) ) {

            $app__comment_meta.addClass( 'moderated' );

          }

        }

/* Don't hide twice */

        if ( $.inArray( $app__comment_id, $app__settings[ 'list' ][ 'hides' ] ) !== -1 ) {

          $app__comment_hide_class += ' disabled';

        }

/* Default action is reply */

      var $app__comment_feedback_action = 'reply';

/* Disable reply and hide of own messages, allow editing of own messages */

        if ( $.inArray( $app__comment_id, $app__settings[ 'list' ][ 'comments' ] ) !== -1 ) {

          $( this ).addClass( 'comment' );

          $app__comment_feedback_class = 'edit cursor-pointer';
          $app__comment_feedback_action = 'edit';
          $app__comments_self = '<small class="dropdown-item cursor-pointer text-dark" data-action="comments-self"><i class="zmdi zmdi-face mr-2"></i>' + $app__text[ 'string' ][ 64 ] + '</small>';

/* Disable hiding of own comment */

          $app__comment_hide_class += ' disabled';

/* Disable editing of own, moderated messages (auto-hide or manual by admin) */

          if ( $app__comment_meta.hasClass( 'moderated' ) && $app__comment_hide_auto === 1 || $app__comment_meta.hasClass( 'moderated hide' ) ) {

            $app__comment_feedback_class += ' disabled';

          }

        }

/* Deprecated avatar-class */

      $app__comment_meta.removeClass( 'A0' );

/* When server-settings allows it, show user-icon with color */

        if ( $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'status' ].hasOwnProperty( 'namecolor' ) ) {

/* $app__namecolor -> -1 : default (gray) avatar | 1 : gray initial | 2 : colored initial */

          $app__namecolor = parseInt( $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'status' ][ 'namecolor' ] );

          if ( $app__namecolor !== -1 && !$( this ).hasClass( 'comment' ) && !$( 'h4', this ).hasClass( 'admin' ) ) {

            var $app__username = 'null';
            var $app__username_tmp = $app__comment_meta.text().trim().substr( 0, 1 ).toLowerCase().replace( /[^a-z0-9]/gi, '' );

              if ( $app__username_tmp !== 'undefined' && $app__username_tmp !== null ) {

                if ( $app__username_tmp.length === 1 ) {

                  $app__username = $app__username_tmp;

                }

              }
            
            $app__comment_meta.addClass( 'name-color name-' + $app__username );
            
            if ( $app__namecolor === 2 ) {

              $app__comment_meta.css( {

                'color' : $app__comment_meta.data( 'color' )

              } );

            }

          }

        }

/* Extend | build the DOM with the action-buttons and username */

      $app__comment_meta.addClass( 'position-relative d-flex mb-3' ).wrapInner( '<span class="w-100 text-truncate pr-2 user-name"></span>' ).append(

        '<span class="text-nowrap user-actions text-brand">' +
        '<b class="badge bg-white badge-pill border border-brand">' + $app__comment_likes + '</b>' +
        '<i class="zmdi zmdi-' + $app__comment_like_class + '" data-action="like"></i>' +
        '<i class="zmdi zmdi-' + $app__comment_feedback_class + '" data-action="' + $app__comment_feedback_action + '"></i>' +
        ( $app__comment_hide !== -1 ? '<i class="zmdi zmdi-' + $app__comment_hide_class + '" data-action="hide"></i>' : '' ) +
        '</span>'

      );

/* Set reply-level */
    
      var $app__reply_class = typeof $app__comment_meta.data( 'level' ) !== 'undefined' ? $app__comment_meta.data( 'level' ) : 0;
    
      $( this ).addClass( 'level-' + $app__reply_class );

/* Check highest reply-level */

      if ( $app__reply_class >= $app__reply_level ) {

        $app__reply_level = $app__reply_class;

      }

    });

/* Star most populair comment */

    if ( $app__comment_starred !== -1 && $app__comment_starred_id !== -1 ) {

      $( $app__comments_article + ' .comments li h4[data-id="' + $app__comment_starred_id + '"]' ).closest( 'li' ).addClass( 'starred' );
      $app__comments_starred = '<small class="dropdown-item cursor-pointer text-dark" data-action="comments-starred"><i class="zmdi zmdi-thumb-up mr-2"></i>' + $app__text[ 'string' ][ 71 ] + '</small>';

    }

/* Create reply-indention | sort-order */

    $( $app__comments_article + ' .comments' ).attr( 'data-level', $app__reply_level );

      if ( $app__reply_level > 0 ) {

        app__order_discussion( $app__comments_article, $app__reply_level );

      }

/* Enable comments-options > at least two comments are needed... */

    var $app__article_button = false;

    if ( $app__comments_index > 1 ) {
      
      $app__article_button = true;
      $app__comments_class = '';

/* ...and it's created only once */

      $app__comments_actions = $( $app__comments_article + ' [data-action=comments-bottom]' ).length ? '' : '<div class="row my-3"><div class="col-6"><div class="dropdown btn-comments">' +

/* Menu-trigger */

      '<small class="text-secondary link-secondary cursor-pointer" data-toggle="dropdown" data-display="static"><i class="zmdi zmdi-comments mr-2"></i>' + $app__text[ 'string' ][ 41 ] + '</small><div class="dropdown-menu text-left py-1 shadow">' +

/* 1. Bottom of list */

      '<small class="dropdown-item cursor-pointer text-dark" data-action="comments-bottom"><i class="zmdi zmdi-download mr-2"></i>' + $app__text[ 'string' ][ 63 ] + '</small>' +

/* 2. Most recent */

      '<small class="dropdown-item cursor-pointer text-dark" data-action="comments-recent"><i class="zmdi zmdi-playlist-plus mr-2"></i>' + $app__text[ 'string' ][ 72 ] + '</small>' +

/* 3. Most liked */

      $app__comments_starred +

/* 4. Own reaction */

      $app__comments_self +

/* 5. Chronological mode */

      '<hr class="my-1">' +

      '<small class="dropdown-item cursor-pointer text-dark" data-action="comments-order-1"><i class="zmdi zmdi-time mr-2"></i>' + $app__text[ 'string' ][ 66 ] + '</small>' +

/* 6. Discussion mode */

      '<small class="dropdown-item cursor-pointer text-dark d-none" data-action="comments-order-2"><i class="zmdi zmdi-comments mr-2"></i>' + $app__text[ 'string' ][ 65 ] + '</small>' +

/* 7. Sort-order */

      '<small class="dropdown-item cursor-pointer text-dark d-none" data-action="comments-reverse"><i class="zmdi zmdi-rotate-right mr-2"></i><span>' + $app__text[ 'string' ][ 67 ] + '</span><span class="d-none">' + $app__text[ 'string' ][ 68 ] + '</span></small>' +
      
      '</div></div></div>' +

/* 8. Smart-button wrapper */

      '<div class="col-6 text-right"><small class="text-secondary link-secondary cursor-pointer btn-smart" data-action="smart-button" data-smart="0"><i class="zmdi zmdi-eye mr-2"></i><span>...</span></small></div></div>';

    }

/* All done - show the comments */

    $( $app__comments_article + ' .comments' ).before( $app__comments_actions ).removeClass( 'd-none mt-4' ).addClass( $app__comments_class );
    $( $app__comments_article + ' [data-action=close].close-down' ).removeClass( 'd-none' ).addClass( 'd-inline-block' );

/* Place the smart-button */

    if ( $app__article_button === true ) {

      $app__article_button = $( $app__comments_article ).closest( 'li' );

      if ( $( $app__comments_article ).closest( 'li' ).find( 'button[data-action=close]').length ) {

        app__article_button( $app__article_button, 1 );

      } else {

        app__article_button( $app__article_button, 2 );

      }

    }

/* Check if a follow-up action is needed : only when it's NOT set to '-1' [no fallback at all] or '1' [user fresh feedback] */

    if ( !parseInt( $app__comment_callback ) ) {

      setTimeout( function() {

        app__overview_recent_show();

      }, $app__scroll_delay );

    }

  } catch( $app__error ) {

    app__error( 'app__comments#03', 5, $app__error );

  }

}

/* ######################################################
  04. Like a comment
###################################################### */

function app__comment_like( $app__like_id, $app__like_src, $app__like_guid ) {

  try {

    var $app__api = 'comment_like';
    $app__url = $app__settings[ 'local' ][ 'api' ] + $app__api + '&like=' + $app__like_id + '&src=' + parseInt( $app__like_src ) + '&url=' + $app__like_guid;

    app__cmd( 'app__comments : like > ' + $app__url );

    var $app__data = app__data();

    $.ajax({

      method: 'post',
      url: $app__url,
      cache: false,
      dataType: 'text',
      data: $app__data,
      complete: function() {

/* 2DO */

      },
      success: function( $app__response, $text_status, $xhr ) {

        var $app__badge = $( 'ol[data-src="' + $app__like_src + '"] li[data-guid="' + $app__like_guid + '"]' ).find( 'h4[data-id="' + $app__like_id + '"] .badge' );

        $app__badge.html( parseInt( $app__response ) ).addClass( 'animate_pulse' );

          setTimeout( function() {

            $app__badge.removeClass( 'animate_pulse' );
      
          }, 5000 );

        app__list_set( 'likes', $app__like_id );
        app__cmd( 'app__comments : comment liked', 1 );

      },
      error: function( $xhr, $text_status, $error ) {

        app__error( 'app__comments#04A', 5, JSON.stringify( $xhr ) );

      }

    });

  } catch( $app__error ) {

    app__error( 'app__comments#04B', 5, $app__error );

  }

}

/* ######################################################
  05. Discussion- comment list actions
###################################################### */

/* -----------------------------------------------------
  #1 | #2  | #3 | #4 > Scroll actions
----------------------------------------------------- */

/* Scroll to the bottom of the list */

$( 'body' ).on( 'click', '[data-action=comments-bottom]', function( $app__event ) {

  try {

    $app__event.preventDefault();
    var $app__scroll_to = $( this ).closest( 'article' ).find( '.comments li:last-of-type' );
    app__comments_scroll( $app__scroll_to );
  
  } catch( $app__error ) {

    app__error( 'app__comments#05A', 5, $app__error );

  }

});

/* Scroll to [the most recent] own comment in the list */

$( 'body' ).on( 'click', '[data-action=comments-self]', function( $app__event ) {
  
  try {
  
    $app__event.preventDefault();
    var $app__scroll_to_list = $( this ).closest( 'article' ).find( '.comments' );
    var $app__scroll_to_item = -1;

    $( 'li.comment', $app__scroll_to_list ).each( function() {

      var $app__scroll_to_tmp = parseInt( $( this ).data( 'index' ) );

      if ( $app__scroll_to_tmp > $app__scroll_to_item ) {

        $app__scroll_to_item = $app__scroll_to_tmp;

      }
      
    });
    
    var $app__scroll_to = $( 'li.comment[data-index=' + $app__scroll_to_item + ']', $app__scroll_to_list );
    app__comments_scroll( $app__scroll_to );

  } catch( $app__error ) {

    app__error( 'app__comments#05B', 5, $app__error );

  }

});

/* Scroll to the most populair comment in the list */

$( 'body' ).on( 'click', '[data-action=comments-starred]', function( $app__event ) {

  try {

    $app__event.preventDefault();
    var $app__scroll_to = $( this ).closest( 'article' ).find( '.comments li.starred' );
    app__comments_scroll( $app__scroll_to );
  
  } catch( $app__error ) {

    app__error( 'app__comments#05C', 5, $app__error );

  }

});

/* Scroll to most recent [general] comment in the list */

$( 'body' ).on( 'click', '[data-action=comments-recent]', function( $app__event ) {
  
  try {
  
    $app__event.preventDefault();
    var $app__scroll_to_list = $( this ).closest( 'article' ).find( '.comments' );
    var $app__scroll_to_item = -1;

    $( 'li', $app__scroll_to_list ).each( function() {

      var $app__scroll_to_tmp = parseInt( $( this ).data( 'index' ) );

      if ( $app__scroll_to_tmp > $app__scroll_to_item ) {

        $app__scroll_to_item = $app__scroll_to_tmp;

      }
      
    });
    
    var $app__scroll_to = $( 'li[data-index=' + $app__scroll_to_item + ']', $app__scroll_to_list );
    app__comments_scroll( $app__scroll_to );

  } catch( $app__error ) {

    app__error( 'app__comments#05D', 5, $app__error );

  }

});

window.app__comments_scroll = function app__comments_scroll( $app__scroll_to ) {

  try {

    if ( $app__scroll_to.length ) {

        $( 'html, body' ).animate( {

          scrollTop: Math.floor( $app__scroll_to.offset().top - $( '.navbar' ).outerHeight() - ( $app__comment_callback === 1 ? 50 : 0 ) ) /* 1 : add 'context' for a user's feedback */

        }, $app__scroll_delay_callback !== -1 ? 500 : 0 ).promise().then( function() { /* -1 : show recent comment at once, no animation delay [quickjump from the top] */

        $app__scroll_to.removeClass( 'animate_highlight' ).addClass( 'animate_highlight' );

        setTimeout( function() {

          $app__scroll_to.removeClass( 'animate_highlight' );
    
        }, 5000 );

      } );

    }

    $app__scroll_delay_callback = 1;

  } catch( $app__error ) {

    app__error( 'app__comments#05E', 5, $app__error );

  }

};

/* -----------------------------------------------------
  #4 > Order actions
----------------------------------------------------- */

/* Toggle threaded- | timed-display of the comments */

$( 'body' ).on( 'click', '[data-action=comments-order-1], [data-action=comments-order-2]', function( $app__event ) {

  try {

    $app__event.preventDefault();

/* 1#2 Chronological mode */

      if ( $( this ).data( 'action' ) === 'comments-order-1' ) {
        
        var $app__comments_list = $( this ).closest( 'article' ).find( 'ol.comments' );
        $( $app__comments_list ).find( 'li' ).sort( app__order_time ).appendTo( $app__comments_list );

/* 2#2 Discussion mode */

      } else {

/* Reset list-order when reversed, before switching to default discussion mode */

        if ( $( this ).closest( 'article' ).hasClass( 'comments-reversed' ) ) {

          $( this ).next( 'small' ).trigger( 'click' );

        }

        var $app__comments_article = $( this ).closest( 'article' );
        var $app__reply_level = $( $app__comments_article ).find( 'ol.comments' ).data( 'level' );
        app__order_discussion( $app__comments_article, $app__reply_level );

      }

/* Toggle display mode */

    $( this ).closest( 'article' ).toggleClass( 'comments-order' );

  } catch( $app__error ) {

    app__error( 'app__comments#05F', 5, $app__error );

  }

});

$( 'body' ).on( 'click', '[data-action=comments-reverse]', function( $app__event ) {

  try {

    $app__event.preventDefault();

    var $app__comments_list = $( this ).closest( 'article' ).toggleClass( 'comments-reversed' ).find( 'ol.comments' );
    $( $app__comments_list ).append( $( $app__comments_list ).find( 'li' ).get().reverse() );

  } catch( $app__error ) {

    app__error( 'app__comments#05G', 5, $app__error );

  }

});

/* ######################################################
  06. Order the comments [threaded]
###################################################### */

function app__order_discussion( $app__comments_article, $app__reply_level ) {

  try {

    var $app__reply_indention = 1;

    while ( $app__reply_indention < $app__reply_level + 1 ) {

      $( $app__comments_article ).find( '.comments li.level-' + $app__reply_indention ).addClass( 'reply-xs' ).each( function() {
        
        var $app__comment_meta = $( this ).find( 'h4' );

/* Re-order any replies */

        var $app__reply_comment = typeof $app__comment_meta.data( 'reply' ) !== 'undefined' ? $app__comment_meta.data( 'reply' ) : -1;

/* 1#3 Comment is first one in row */

        var $app__reply_parent = $app__reply_text = $( this ).closest( 'ol' ).find( 'li h4[data-id="' + $app__reply_comment + '"]' );

/* 2#3 Other comments are already active */

        var $app__reply_parent_tmp = $( this ).closest( 'ol' ).find( 'li[data-reply="' + $app__reply_comment + '"]' );

/* ...not the first reply */

          if ( $app__reply_parent_tmp.length ) {

            $app__reply_parent = $app__reply_parent_tmp.removeAttr( 'data-reply' ).find( 'h4' );

/* ...first reply in line */

          } else {

            $( this ).removeClass( 'reply-xs' ).addClass( 'reply-lg' );

          }
  
/* 3#3 Fire current comment for any future references [previous one is reseted above] */
  
          if ( $app__reply_comment !== -1 ) {

            $( this ).attr( 'data-reply',  $app__reply_comment );

/* Place current comment after the most recent replied one (when available) - when settings (app-level or article-level) allow it */

            if ( $app__reply_parent.length ) {

              if ( $app__settings[ 'user' ][ 'comments_order' ] !== true ) {

                $app__reply_parent.parent().after( $( this ) );

              }

/* Remove closed-tags and <br> from original quote > then remove emojis and trim the string - when not already done */

              if ( !$( this ).find( '.reply-entry' ).length && $app__reply_text.length ) {

                $app__reply_text = $app__reply_text.next( 'p' ).html();

                if ( $app__reply_text !== undefined ) {

                  $app__reply_text = $app__reply_text.replace( /<span class="reply-.*>.*?<\/span>|<([^>]+)>/ig, ' ' );
                  $app__reply_text = $app__reply_text.replace( /([\uE000-\uF8FF]|\uD83C[\uDC00-\uDFFF]|\uD83D[\uDC00-\uDFFF]|[\u2011-\u26FF]|\uD83E[\uDD10-\uDDFF])/g, '' );
                  $app__reply_text = $app__reply_text.substring( 0, $app__reply_length ).replace(/  /ig, ' ').trim();

                } else {

                  $app__reply_text = '';

                }

                if ( $app__reply_text.length < 1 || $app__reply_text === ' ' ) {

                  $app__reply_text = '...';

                }
  
                $( this ).find( 'b.mention' ).wrap( '<span class="reply-entry clearfix"></span>' ).after( '<i class="quote">' + $app__reply_text +'</i>' );
  
              }

            }

          }
  
      });

      $app__reply_indention++;

    }

/* Reset latest - most recent parsed - replies */

    $( $app__comments_article ).find( '.comments li[data-reply]' ).removeAttr( 'data-reply' );

  } catch( $app__error ) {

    app__error( 'app__comments#06', 5, $app__error );

  }

}

/* ######################################################
  07. Order the comments [chronological]
###################################################### */

window.app__order_time = function app__order_time( $app__comment_a, $app__comment_b ) {

  try {

    return ( $( $app__comment_b ).data( 'index' ) ) < ( $( $app__comment_a ).data( 'index' ) ) ? 1 : -1;

  } catch( $app__error ) {

    app__error( 'app__comments#07A', 5, $app__error );

  }

}

/* -----------------------------------------------------
  Order the comments discussion- or chronological-mode
----------------------------------------------------- */

window.app__order_comments = function app__order_comments() {

  try {

/* Reset any reversed (backwards) comment-list */

    $( 'article.comments-reversed' ).each( function() {

      $( this ).find( '[data-action=comments-reverse]' ).trigger( 'click' );

    });

/* Clear any chronological comment-list */

    $( 'article.comments-order' ).removeClass( 'comments-order' );

/* Parse every defaulted comment-list */

    $( 'ol.comments' ).each( function() {

/* 1#2 > order on time */

      if ( $app__settings[ 'user' ][ 'comments_order' ] === true ) {

        $( 'li', this ).sort( app__order_time ).appendTo( this );

/* 2#2 > order on discussion */

      } else {

        var $app__comments_article = $( this ).closest( 'article' );
        var $app__reply_level = $( this ).data( 'level' );
        app__order_discussion( $app__comments_article, $app__reply_level );

      }

    });

  } catch( $app__error ) {

    app__error( 'app__comments#07B', 5, $app__error );

  }

}

/* ######################################################
  08. Scroll to a mentioned-comment
###################################################### */

$( 'body' ).on( 'click', 'b.mention', function( $app__event ) {

  try {

    $app__event.preventDefault();

    var $app__scroll_to = $( 'li h4[data-id="' + $( this ).closest( 'li' ).find( 'h4' ).data( 'reply' ) + '"]' ).parent();
    app__comments_scroll( $app__scroll_to );

  } catch( $app__error ) {

    app__error( 'app__comments#08', 5, $app__error );

  }

});

/* ######################################################
  09. Hide a comment
###################################################### */

function app__comment_hide( $app__hide_id, $app__hide_src, $app__hide_guid, $app__hide_item /* , $app__hide_score */ ) {

  try {

    var $app__api = 'comment_hide';
    $app__url = $app__settings[ 'local' ][ 'api' ] + $app__api + '&hide=' + $app__hide_id + '&src=' + parseInt( $app__hide_src ) + '&url=' + $app__hide_guid;

    app__cmd( 'app__comments : hide > ' + $app__url );

    var $app__data = app__data();
    $app__data[ 'app__hide_item' ] = $app__hide_item;
    /* $app__data[ 'app__hide_score' ] = $app__hide_score; */

    $.ajax({

      method: 'post',
      url: $app__url,
      cache: false,
      dataType: 'text',
      data: $app__data,
      complete: function() {

/* 2DO */

      },
      success: function( $app__response, $text_status, $xhr ) {

        app__list_set( 'hides', $app__hide_id );
        app__cmd( 'app__comments : comment hide #' + $app__response, 1 );

      },
      error: function( $xhr, $text_status, $error ) {

        app__error( 'app__comments#09A', 5, JSON.stringify( $xhr ) );

      }

    });

  } catch( $app__error ) {

    app__error( 'app__comments#09B', 5, $app__error );

  }

}

/* Show hidden comment */

$( 'body' ).on( 'click', 'ol.comments .btn-hide', function( $app__event ) {

  try {

    $app__event.preventDefault();
    
    var $app__hide_button = $( this );
    
    $app__hide_button.fadeOut( 500, function() {

      $app__hide_button.remove();

    } );

  } catch( $app__error ) {

    app__error( 'app__comments#09C', 5, $app__error );

  }

});

/* -----------------------------------------------------
  Catch me if you can
----------------------------------------------------- */

app__cmd( 'app__comments : script loaded' );

} catch ( $app__error ) {

  app__error( 'app__comments#00', 5, $app__error.message );

} }(jQuery));