/* ======================================================

T.O.C. [table of contents]

01. Fetch and render the discussion block

====================================================== */

;(function ( $ ) { try {

/* ######################################################
  01. Render the discussion [when needed]
###################################################### */

window.app__discussion_fetch = function app__discussion_fetch() {

  try {

    var $app__discussion_item = 'li[data-guid^=discussion-]';

    if ( $( $app__discussion_item ).length ) {

      var $app__discussion_id = 'app__source_00';
      var $app__discussion_parent = '#' + $( $app__discussion_item ).parent().attr( 'id' );
      var $app__discussion_source = $( $app__discussion_item ).parent().attr( 'data-src' );

/* Check the header-title, set by the server [can change per subject] */

      var $app__discussion_title = app__format_string( $app__text[ 'string' ][ 0 ], 1 );

      if ( $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'status' ].hasOwnProperty( 'discussion_title' ) ) {

        $app__discussion_title = $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'status' ][ 'discussion_title' ];
        $app__discussion_title = $app__discussion_title.trim();

/* If 'text' is -1, don't render the discussion-block [will be placed on top of the default list-items] */

        if ( !isNaN( $app__discussion_title ) ) {

          if ( parseInt( $app__discussion_title ) === -1 ) {

            return;

          }

        }

      }

/* Check the header-text, set by the server [can change per subject] */

      var $app__discussion_text = '';

      if ( $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'status' ].hasOwnProperty( 'discussion_text' ) ) {

        $app__discussion_text = $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'status' ][ 'discussion_text' ];
        $app__discussion_text = $app__discussion_text.trim();

        if ( $app__discussion_text.length > 1 && $app__discussion_text !== ' ' ) {
          
          $app__discussion_text = '<div>' + $app__discussion_text + '</div>';
        
        }

      }

/* Create the discussion wrapper and -header (before the first regular news-source) */

      $( '#app__news' ).prepend( '<ol class="list-unstyled" id="' + $app__discussion_id + '" data-src="' + $app__discussion_source + '"><li><h4 class="bg-brand text-uppercase font-weight-bold text-center py-2 mb-3 shadow title-secondary"><b>' + $app__discussion_title + '</b></h4>' + $app__discussion_text + '</li></ol>' );

/* Move the discussion-topic(s) from the regular news-item to the discussion-wrapper (and remove deprecated styles) */

      var $app__discussion_items = 0;

      $( $app__discussion_item ).each( function() {
        
        $app__discussion_items++;
        
        var $app__discussion_class = $app__discussion_items === 1 ? 'border-top pt-3 ' : '';
        
        $( this ).detach().appendTo( '#' + $app__discussion_id ).removeClass( $app__discussion_class + 'featured pinned' ).find( 'span.pin' ).remove().end().find( 'h3 > .zmdi-star' ).remove().end().find( 'br.d-md-none' ).remove();

      });

/* Re-create the existing list, where the discussion-item was fetched from */

      if ( $( $app__discussion_parent + ' li:nth-child( 2 ):not( .archive )' ).length ) {

/* Style the 'new' first-entry as featured in the regular news-source */
      
        $( $app__discussion_parent + ' li:nth-child( 2 )' ).removeClass( 'border-top pt-3' ).addClass( 'featured' );

/* Show some more list-items from the archive in the regular list -> when available */

        if ( $( $app__discussion_parent + ' li.archive + li' ).length ) {

          for ( var $app__i = 0; $app__i < $app__discussion_items; $app__i++ ) {

/* Once again, check if any 'entry after the archive button' is available */

            if ( $( $app__discussion_parent + ' li.archive + li' ).length ) {

/* Move the archived-entry 'before' the archive-treshold */

              $( $( $app__discussion_parent + ' li.archive + li' ) ).insertBefore( $app__discussion_parent + ' li.archive' );

              if ( !$( $app__discussion_parent + ' li.archive + li' ).length ) {

/* Delete archive-button when no archived items are available */

                $( $app__discussion_parent + ' li.archive' ).remove();

              }

            }
          
          }
        
        } else {

          $( $app__discussion_parent + ' li.archive' ).remove();
  
        }

      } else {

        $( $app__discussion_parent + ' li.archive' ).remove();

      }

    }

  } catch( $app__error ) {

    app__error( 'app__discussion#01', 15, $app__error );

  }

};

/* -----------------------------------------------------
  Catch me if you can
----------------------------------------------------- */

  app__cmd( 'app__discussion : script loaded' );

} catch ( $app__error ) {

  app__error( 'app__discussion#00', 15, $app__error.message );

} }( jQuery ));