/* ======================================================

  T.O.C. [table of contents]

  01. Fire the send button
  02. Send the feedback
  03. Show the result
  04. Check all required input fields
  05. Resize textarea
  06. Set user-name
  07. Change user-name
  08. Set user-color
  09. Set user-pin
  10. Show user-pin

====================================================== */

var $app__feedback_src, $app__feedback_guid, $app__feedback_id = '';
var $app__namechange = false;

;(function ( $ ) { try {

/* ######################################################
  01. Enable the send button
###################################################### */

$( document ).on( 'click', '[data-action=send]:not(.disabled)', function( $app__event ) {

  try {
    
    $app__event.preventDefault();

    $( this ).addClass( 'disabled' );
    $( '.modal' ).removeClass( 'namechange-disabled' );

/* Reset namechange-hint when needed */    

      if ( $( 'form.form-feedback #name' ).hasClass( 'font-weight-bold' ) ) {

        $( 'form.form-feedback #name' ).val( $app__settings[ 'user' ][ 'name' ] ).removeClass( 'font-weight-bold' );

      }

      if ( $( 'form.form-feedback #name' ).val().toLowerCase() === $app__text[ 'string' ][ 51 ].toLowerCase() ) {

        $( 'form.form-feedback #name' ).val( '' );

      }

/* 1#3 > check if form contains errors */

  var $app__feedback_check = app__feedback_check();

    if ( $app__feedback_check > 0 ) {

      $( this ).removeClass( 'disabled' );
      return false;

/* 2#3 > check if name-change is required -> ask for confirm */

    } else if (
      
      $app__settings[ 'user' ][ 'name' ] !== $( 'form.form-feedback #name' ).val() &&
      $app__settings[ 'user' ][ 'name' ].trim() !== '' &&
      $app__settings[ 'user' ][ 'name' ].trim().length > 1 &&
      $app__namechange === true

    ) {
      
      if ( $app__settings[ 'user' ][ 'namechange' ] > 0 ) {

        $( '[data-namechange=old]' ).text( $app__settings[ 'user' ][ 'name' ].trim().length > 1 ? $app__settings[ 'user' ][ 'name' ] : '???' );
        $( '[data-namechange=new]' ).text( $( 'form.form-feedback #name' ).val() );
        $( '.modal .namechange-enabled' ).html( $app__text[ 'string' ][ 46 ].replace( '{#}', $app__settings[ 'user' ][ 'namechange' ] ) );
        $( '.modal' ).addClass( 'namechange-enabled' );

      } else {

        $( '.modal' ).addClass( 'namechange-disabled' );
        $( 'form.form-feedback #name' ).val( $app__settings[ 'user' ][ 'name' ] );
        $app__namechange = false;

      }

      $( this ).removeClass( 'disabled' );
      return false;

    } else {

/* 3#3 > check if name-pin is required [ 1 ] by settings / is set by user [ -1 : not set at all | 0 : set but invalid | (int) : valid ] / not for email [pin forgot request] */
    
      app__user_set( 'name', $( 'form.form-feedback #name' ).val() );
      app__user_set( 'color', $( 'form.form-feedback #color' ).val() );

        if ( $app__namepin === 1 && parseInt( $app__settings[ 'user' ][ 'pin' ] ) < 1 && !$( '.modal-feedback.mail' ).length ) {

          $( '.modal' ).addClass( 'modal-namepin screen-namepin-1' );
          $( this ).removeClass( 'disabled' );
          return false;
        
        }

/* Good to go */

      app__loading_button( $( this ) );
      
      $( '.modal form.form-feedback .form-control' ).prop( 'readonly', true );
      $( '.modal form.form-feedback .form-control, [data-action=namechange]' ).addClass( 'disabled' );

      app__feedback_send( $app__feedback_src, $app__feedback_guid );

    }

  } catch( $app__error ) {

    app__error( 'app__feedback#01', 8, $app__error );

  }

});

/* ######################################################
  02. Send the feedback
###################################################### */

function app__feedback_send( $app__feedback_src, $app__feedback_guid ) {

  try {

/* Feedback > comment [default] */

    var $app__api = 'comment';
    $app__url = $app__settings[ 'local' ][ 'api' ] + $app__api + '&src=' + parseInt( $app__feedback_src ) + '&url=' + $app__feedback_guid;

/* Feedback > mail */

    if ( $( '.modal-feedback.mail' ).length ) {

      $app__api = 'mail';
      $app__url = $app__settings[ 'local' ][ 'api' ] + $app__api;

    }

    app__cmd( 'app__feedback : loading > ' + $app__url );

    $.ajax( {

      method: 'post',
      url: $app__url,
      cache: false,
      dataType: 'text',
      data: $( '.modal form.form-feedback' ).serialize(),
      complete: function() {

/* 2DO */

      },
      success: function( $app__response, $text_status, $xhr ) {

        var $app__feedback = $app__response;

          if ( $app__feedback.length < 3 ) {

            $app__feedback = '<b>' + $app__text[ 'error' ][ 8 ] + '</b>';

          }

        app__feedback_show( $app__feedback, $app__feedback_src, $app__feedback_guid );

        app__cmd( 'app__feedback : feedback loaded', 1 );

      },
      error: function( $xhr, $text_status, $error ) {

        app__error( 'app__feedback#02A', 8, JSON.stringify( $xhr ) );

      }

    } );

  } catch( $app__error ) {

    app__error( 'app__feedback#02B', 8, $app__error );

  }

}

/* ######################################################
  03. Update and parse the feedback
###################################################### */

function app__feedback_show( $app__feedback, $app__feedback_src, $app__feedback_guid ) {

  try {

    var $app__feedback = $app__feedback || null;
    var $app__feedback_src = $app__feedback_src || null;
    var $app__feedback_guid = $app__feedback_guid || null;

/* -----------------------------------------------------
  1#2 > Feedback : mail
----------------------------------------------------- */

/* User has send a mail, show confirmation */

    if ( $( '.modal-feedback.mail' ).length ) {

      $( '.modal' ).addClass( 'confirm' );
      $( '.modal-body .confirm' ).html( $app__feedback );

    }

/* -----------------------------------------------------
  2#2 > Feedback : comment
----------------------------------------------------- */

/* Update the comments - create comments-wrapper when it's the first comment */

    if ( $( '.modal-feedback.comment' ).length ) {

      var $app__feedback_comments = $( 'ol[data-src="' + $app__feedback_src + '"] li[data-guid="' + $app__feedback_guid + '"] article .comments' );

        if ( !$app__feedback_comments.length ) {

          $( 'ol[data-src="' + $app__feedback_src + '"] li[data-guid="' + $app__feedback_guid + '"] article .article' ).after( '<ol class="comments"></ol>' );

          $app__feedback_comments = $( 'ol[data-src="' + $app__feedback_src + '"] li[data-guid="' + $app__feedback_guid + '"] article .comments' );

        }
      
      $app__feedback_comments.addClass( 'd-none' ).html( '' ).append( $app__feedback );

/* Get and save the feedback entry for future reference */

      $app__feedback_comments.find( 'li' ).each( function() {

        if ( $( 'h4', this ).data( 'id' ).indexOf( $app__feedback_id ) !== -1 ) {

          $app__feedback_id = $( 'h4', this ).data( 'id' );

/* Update default lists with some meta-data */

          app__list_set( 'comments', $app__feedback_id );
          app__list_set( 'commented',  $app__feedback_guid + '|' + $( $app__feedback_comments ).find( 'li' ).length );

/* Update most-recent comments in personal-menu -> '|' divider will save most recent comment only [prevent article duplicates] */

          app__personal_list( 'personal-comments', $app__feedback_guid + '|' + $app__feedback_id );
          app__personal_comments_fetch();

        }

      });

/* Load, fire and parse the updated comments */

      app__comments_parse( $app__feedback_src, $app__feedback_guid );

/* When the updated article-comments has 'view settings' [display-mode / reversed-order] obey them after parsing */

      var $app__feedback_article = $app__feedback_comments.closest( 'article' );

      if ( $( $app__feedback_article ).hasClass( 'comments-order' ) ) {

        $( $app__feedback_article ).removeClass( 'comments-order' ).find( '[data-action=comments-order-1]' ).trigger( 'click' );
  
      }

      if ( $( $app__feedback_article ).hasClass( 'comments-reversed' ) ) {
          
        $( $app__feedback_article ).removeClass( 'comments-reversed' ).find( '[data-action=comments-reverse]' ).trigger( 'click' );

      }

/* Hide the modal when done */

      $( '.modal' ).modal( 'hide' );

/* Scroll to and highlight the users feedback [when available] */

      var $app__feedback_comment = $( 'ol[data-src="' + $app__feedback_src + '"] li[data-guid="' + $app__feedback_guid + '"] h4[data-id="' + $app__feedback_id + '"]' ).parent();

      if ( $app__feedback_comment.length ) {

        setTimeout( function() {

          $app__comment_callback = 1;

          app__comments_scroll( $app__feedback_comment );

          setTimeout( function() {

            $app__comment_callback = -1;

          }, 500 );      

        }, $app__modal_speed * 3 );

      }

    }

  } catch( $app__error ) {

    app__error( 'app__feedback#03', 8, $app__error );

  }

}

/* ######################################################
  04. Check the input for errors
###################################################### */

function app__feedback_check() {

  try {

    var $app__errors = 0;

    $( '[required]:visible' ).each( function() {
      
      $( this ).val( $( this ).val().replace(/ +/g, ' ').trim() );
      
      if ( $( this ).val().length < 2 ) {

        $app__errors++;
        $( this ).addClass( 'error' );

      }
      $app__check_type = $( this ).attr( 'type' );

      if ( typeof $app__check_type !== typeof undefined && $app__check_type !== false ) {

        if ( $app__check_type.toLowerCase() === 'email' ) {
      
          $app__check_mail = /^([a-zA-Z0-9_.+-])+\@(([a-zA-Z0-9-])+\.)+([a-zA-Z0-9]{2,4})+$/.test( $( this ).val() );
   
           if ( $app__check_mail !== true ) {
   
             $app__errors++;
             $( this ).addClass( 'error' );
     
           }
   
         }
   
      }

    });

    return $app__errors;

  } catch( $app__error ) {

    app__error( 'app__feedback#04', 8, $app__error );

  }

}

/* Reset errors on focus */

$( '[required]' ).on( 'click focus', function() {

  $( this ).removeClass( 'error' );

});

/* ######################################################
  05. Resize textarea
###################################################### */

$( document ).on( 'click', '[data-action^=resize-]', function( $app__event ) {

  try {

    $app__event.preventDefault();
    var $app__resize = $( this ).attr( 'data-action' );

    switch ( $app__resize ) {

      case 'resize-max':

        $( this ).closest( '.modal-dialog' ).addClass( 'resized' );

      break;

      case 'resize-min':

        $( this ).closest( '.modal-dialog' ).removeClass( 'resized' );

      break;

    }

  } catch( $app__error ) {

    app__error( 'app__feedback#05', 8, $app__error );

  }

});

/* ######################################################
  06. Set nickname display-logic in the feedback-form
###################################################### */

window.app__namechange = function app__namechange() {

  try {

    if ( $app__settings[ 'user' ][ 'name' ] !== '' && $app__settings[ 'user' ][ 'name' ].length > 1 ) {

      $( 'form.form-feedback .namechange' ).removeClass( 'input-group-disabled' ).addClass( 'input-group' );
      $( 'form.form-feedback #name').prop( 'readonly', true ).addClass( 'disabled' ).val( $app__settings[ 'user' ][ 'name' ] ).removeClass( 'font-weight-bold' );
      $('[data-action=namechange]' ).removeClass( 'animate_size_pulse' );

    }

  } catch( $app__error ) {

    app__error( 'app__feedback#06', 8, $app__error );

  }

}

/* ######################################################
  07. Change nickname
###################################################### */

/* Click on the 'change my nickname' unlock-button */

$( '[data-action=namechange]' ).on( 'click', function( $app__event ) {

  try {

    $app__event.preventDefault();
    $app__namechange = true;

    $( 'form.form-feedback .namechange' ).removeClass( 'input-group' ).addClass( 'input-group-disabled' );
    $( 'form.form-feedback #name').prop( 'readonly', false ).removeClass( 'disabled font-weight-bold' ).val( '' ).focus();

  } catch( $app__error ) {

    app__error( 'app__feedback#07A', 8, $app__error );

  }

});

/* Click on the 'confirm | cancel my new nickname' button */

$( '[data-namechange]' ).on( 'click', function( $app__event ) {

  try {

    $app__event.preventDefault();
    $app__namechange = false;

    $( 'form.form-feedback #name').val( $( this ).text() );
    app__user_set( 'name', $( 'form.form-feedback #name' ).val() );

      if ( $( this ).data( 'namechange' ) === 'new' ) {
        
        $app__settings[ 'user' ][ 'namechange' ] -= 1;

        if ( $app__settings[ 'user' ][ 'namechange' ] < 0 ) {

          $app__settings[ 'user' ][ 'namechange' ] = 0;

        }

        app__user_set( 'namechange', '' + $app__settings[ 'user' ][ 'namechange' ] );

      }
  
    $( '.modal' ).removeClass( 'namechange-enabled' );
    $( '[data-action=send]' ).trigger( 'click' );

  } catch( $app__error ) {

    app__error( 'app__feedback#07B', 8, $app__error );

  }

});

/* Give a visual hint, when trying to edit a locked nickname-field */

$( document ).on( 'click', '.modal .namechange', function( $app__event ) {

  try {

    var $app__target = $( $app__event.target );
    $('[data-action=namechange]' ).removeClass( 'animate_size_pulse' );

    if ( $('[data-action=namechange]:visible' ).length && !$('.modal form.form-feedback textarea:disabled' ).length && !$app__target.is( 'button' ) ) {

      $('[data-action=namechange]' ).addClass( 'animate_size_pulse' );
      $( 'form.form-feedback #name').val( $app__text[ 'string' ][ 51 ] ).addClass( 'font-weight-bold' );

      setTimeout( function() {

        if ( $('[data-action=namechange]:visible' ).length ) {

          $( 'form.form-feedback #name').val( $app__settings[ 'user' ][ 'name' ] ).removeClass( 'font-weight-bold' );

        }
  
      }, 5000 );  

    }

  } catch( $app__error ) {

    app__error( 'app__feedback#07C', 8, $app__error );

  }

});

/* ######################################################
  08. Set usercolor
###################################################### */

window.app__namecolor = function app__namecolor() {

  try {

    var $app__namecolor = '';

/* #ABCDEF : namespacing of a correct color */

    var $app__namecolor_length = 7;

/* 0 ~ 1 : defaults to 0.618 -> prevents similar colors */

    var $app__namecolor_ratio = 0.618;

/* 0 ~ 100 : defaults to 1  -> see above */

    var $app__namecolor_percentage = 1;

/* 0 ~ 1 : defaults to 0.5 -> lower is grayer */

    var $app__namecolor_saturation = 0.35;

/* 0 ~ 1 : defaults to 0.95 -> lower is darker */

    var $app__namecolor_value = 0.65;

    if ( $app__settings[ 'user' ][ 'color' ] === '' || $app__settings[ 'user' ][ 'color' ].length !== $app__namecolor_length ) {

      var $app__namecolor_create = function(r){function t(e){if(n[e])return n[e].exports;var o=n[e]={i:e,l:!1,exports:{}};return r[e].call(o.exports,o,o.exports,t),o.l=!0,o.exports}var n={};return t.m=r,t.c=n,t.i=function(r){return r},t.d=function(r,n,e){t.o(r,n)||Object.defineProperty(r,n,{configurable:!1,enumerable:!0,get:e})},t.n=function(r){var n=r&&r.__esModule?function(){return r.default}:function(){return r};return t.d(n,"a",n),n},t.o=function(r,t){return Object.prototype.hasOwnProperty.call(r,t)},t.p="",t(t.s=3)}([function(r,t,n){"use strict";r.exports=function(r,t,n){var e=Math.floor(6*r),o=6*r-e,u=n*(1-t),a=n*(1-o*t),c=n*(1-(1-o)*t),i=255,f=255,s=255;switch(e){case 0:i=n,f=c,s=u;break;case 1:i=a,f=n,s=u;break;case 2:i=u,f=n,s=c;break;case 3:i=u,f=a,s=n;break;case 4:i=c,f=u,s=n;break;case 5:i=n,f=u,s=a}return[Math.floor(255*i),Math.floor(255*f),Math.floor(255*s)]}},function(r,t,n){"use strict";var e=n(2);r.exports=function(r){var t=r.map(function(r){return e(r.toString(16))}).join("");return"#"+t}},function(r,t,n){"use strict";var e=2;r.exports=function(r){return r.length>e?r:new Array(e-r.length+1).join("0")+r}},function(r,t,n){"use strict";function e(){var r=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},t=r.hue,n=r.saturation,e=r.value;return t||(t=Math.random()),t+=c,t%=1,"number"!=typeof n&&(n=.5),"number"!=typeof e&&(e=.95),u(t,n,e)}function o(r,t){var n=e(r,t);return a(n)}var u=n(0),a=n(1),c=.618033988749895;r.exports=o}]);

      $app__namecolor = $app__namecolor_create( {

        hue: ( Math.random() + $app__namecolor_ratio ) % $app__namecolor_percentage,
        saturation: $app__namecolor_saturation,
        value: $app__namecolor_value

      } ).toUpperCase();

    } else {

      $app__namecolor = $app__settings[ 'user' ][ 'color' ];

    }

    $( 'form.form-feedback #color').val( $app__namecolor );

  } catch( $app__error ) {

    app__error( 'app__feedback#08', 8, $app__error );

  }

}

/* ######################################################
  09. Set userpin
###################################################### */

/* -----------------------------------------------------
  Cancel and return to message-screen
----------------------------------------------------- */

$( '[data-namepin=cancel]' ).on( 'click', function( $app__event ) {

  try {

    $app__event.preventDefault();

/* Re-submit the form when pin is saved in screen #3 */

    if ( $ ( '.modal-namepin.screen-namepin-3' ).length ) {

      setTimeout( function() {

        $( '.modal [data-action=send]' ).removeClass( 'invisible' ).trigger( 'click' );

      }, 750 );

    }

/* Re-set the modal's visual identity */

    $( '.modal' ).removeClass( 'modal-namepin screen-namepin-1 screen-namepin-2 screen-namepin-3' );

  } catch( $app__error ) {

    app__error( 'app__feedback#09A', 8, $app__error );

  }

});

/* -----------------------------------------------------
  Show next step / screen
----------------------------------------------------- */

$( '[data-namepin=next]' ).on( 'click', function( $app__event ) {

  try {

    $app__event.preventDefault();

/* Screen 1 > screen 2 */

    if ( $( '.modal.screen-namepin-1' ).length ) {

      $( '.modal' ).removeClass( 'screen-namepin-1' ).addClass( 'screen-namepin-2' );
      
      $( '#namepin-1, #namepin-2' ).removeClass( 'error' ).val( '' );
      $( '#namepin-1 + small, #namepin-2 + small' ).fadeIn( 0 );
      $( '#namepin-1 + small + small, #namepin-2 + small + small' ).fadeOut( 0 );


/* Screen 2 > screen 3 [check input] */

    } else {
      
      $( '#namepin-1' ).val( $( '#namepin-1' ).val().replace( /[^0-9]/g,'' ) );

      var $app__namepin_tmp_1 = $( '#namepin-1' ).val()
      var $app__namepin_tmp_2 = $( '#namepin-2' ).val();

/* Error - 1st number is not valid */

      if (
        
        isNaN( parseInt( $app__namepin_tmp_1 ) ) || /* must be a number */
        parseInt( $app__namepin_tmp_1 ) < 1 ||      /* number is not zero */
        $app__namepin_tmp_1.trim() === '' ||        /* string is not empty */
        $app__namepin_tmp_1 === ' ' ||              /* string is not a space */
        $app__namepin_tmp_1.length < 2 ||           /* string is at least two digits */
        $app__namepin_tmp_1.length > 8              /* string is not longer than eight digits */

      ) {

        $( '#namepin-1' ).addClass( 'error' );

        $( '#namepin-1 + small' ).fadeOut( 500, function() {

          $( '#namepin-1 + small + small' ).removeClass( 'd-none' ).fadeOut( 0 ).fadeIn( 500 );

        } );

        if ( $app__namepin_tmp_2.length ) {

          $( '#namepin-2' ).addClass( 'error' );

        }

        return;

/* Error - 2nd number does not match 1st */

      } else if ( $app__namepin_tmp_2 !== $app__namepin_tmp_1 ) {
        
        $( '#namepin-2' ).addClass( 'error' );

        $( '#namepin-2 + small' ).fadeOut( 500, function() {

          $( '#namepin-2 + small + small' ).removeClass( 'd-none' ).fadeOut( 0 ).fadeIn( 500 );

        } );

        return;

/* Okay - save and continue */

      } else {
        
        var $app__namepin_final = $app__namepin_tmp_1;
        app__user_set( 'pin', $app__namepin_final );
        
        $( 'b[data-namepin=var1]' ).text( app__user_get( 'name' ) );
        $( 'b[data-namepin=var2]' ).text( app__user_get( 'pin' ) );

/* Show screen 3 */

        $( '.modal' ).removeClass( 'screen-namepin-2' ).addClass( 'screen-namepin-3' );

        setTimeout( function() {
  
          $( 'b[data-namepin=var2]' ).parent().addClass( 'animate_bounce' );
      
        }, 1000 );

/* Prepare feedback-form for final submit */

        $( '.modal form.form-feedback #pin' ).val( app__user_get( 'pin' ) );
        $( '.modal form.form-feedback .form-control' ).prop( 'readonly', true );
        $( '.modal form.form-feedback .form-control, .modal form.form-feedback [data-action=namechange]' ).addClass( 'disabled' );
        $( '.modal [data-action=send]' ).addClass( 'invisible' );
  
      }

    }

  } catch( $app__error ) {

    app__error( 'app__feedback#09B', 8, $app__error );

  }

});

/* -----------------------------------------------------
  Restrict numbers only
----------------------------------------------------- */

$( document ).on( 'focus', '#namepin-2.error', function() {
  
  try {

    $( '#namepin-2 + small + small' ).fadeOut( 500, function() {

      $( '#namepin-2 + small' ).fadeIn( 500 );

    } );
  
  } catch( $app__error ) {

    app__error( 'app__feedback#09C', 8, $app__error );

  }

});

$( '#namepin-1, #namepin-2' ).on( 'keyup paste input blur focus', function() {
  
  try {

    $( this ).val( $( this ).val().replace( /[^0-9]/g,'' ) );
    $( '#namepin-1, #namepin-2' ).removeClass( 'error' );

  } catch( $app__error ) {

    app__error( 'app__feedback#09D', 8, $app__error );

  }

});

/* -----------------------------------------------------
  'Forgot pin' request [pin is not required this time]
----------------------------------------------------- */

$( '[data-namepin=forgot]' ).on( 'click', function( $app__event ) {

  try {

    $app__event.preventDefault();
    
    setTimeout( function() {

      app__prepare_mail();
      $( '.modal' ).find( 'form.form-feedback #text' ).val( $app__text[ 'string' ][ 80 ] );

    }, 1500 );

  } catch( $app__error ) {

    app__error( 'app__feedback#09E', 8, $app__error );

  }

});


/* ######################################################
  10. Show userpin
###################################################### */

$( '#app__pin:not( .disabled )' ).on( 'click', function( $app__event ) {

  try {

    $app__event.preventDefault();

    $( this ).addClass( 'disabled' ).find( 'span:last-of-type' ).removeClass( 'd-none' ).fadeOut( 0 ).fadeIn( 1000, function() {

      setTimeout( function() {

        $( '#app__pin span:last-of-type' ).fadeOut( 1000, function() {

          $( '#app__pin' ).removeClass( 'disabled' );

        } );
  
      }, 5000 );
  
    } );

  } catch( $app__error ) {

    app__error( 'app__feedback#10', 8, $app__error );

  }

});

/* -----------------------------------------------------
  Catch me if you can
----------------------------------------------------- */

app__cmd( 'app__feedback : script loaded' );

} catch ( $app__error ) {

  app__error( 'app__feedback#00', 8, $app__error.message );

} }(jQuery));