/* ======================================================

  T.O.C. [table of contents]

  01. Start the app
  02. Initialize the app
  03. Load the server-settings
  04. Parse the server-settings
  05. Check for server-message | show message
  06. Update the progressbar
  07. Define the header images
  08. Check useragent
  09. Restart the app
  10. Version check | show update
  11. Get | set the unique user #ID

====================================================== */

var $app__message = [];
var $app__ua_w10m = $app__ua_android = $app__ua_android_version = false;
var $app__refresh_start = $app__refresh_resume = $app__refresh_tombstoned = $app__refresh_difference = $app__refresh_allowed = 0;
var $app__interstitial, $app__interstitial_show, $app__interstitial_scroll, $app__namechange, $app__namepin, $app__readonly, $app__killswitch;
var $app__image_api_xs = $app__image_api_xl = '-1';
var $app__comment_hide_auto = $app__comment_hide = $app__comment_starred = -1;

;(function ( $ ) { try {

/* ######################################################
  01. Bootstrap the app
###################################################### */

window.app__initialize = function app__initialize() {

  try {

/* Check user-agent for additional classes */

    app__device();

/* App-name */

    document.title = ( $app__settings[ 'local' ][ 'debug' ] === true ? '[debug] ' : '' ) + app__format_string( $app__text[ 'string' ][ 0 ] );
    $( 'h1' ).html( $app__text[ 'string' ][ 0 ] );

/* Footer meta-data [static strings] */

    $( 'footer [data-name]' ).text( app__format_string( $app__settings[ 'local' ][ 'name' ], 1 ) );
    $( 'footer [data-action=promote-whatsapp] span' ).text( $app__text[ 'string' ][ 9 ] );
    $( 'footer [data-app]' ).text( $app__text[ 'string' ][ 56 ] + ' ' + $app__settings[ 'local' ][ 'version' ] );
    $( 'footer #app__backkey small' ).text( $app__text[ 'string' ][ 95 ] );

/* Body */

    $( '[data-time=local] b:first-of-type' ).text( $app__text[ 'string' ][ 10 ] );
    $( '[data-action=restart] b:first-of-type' ).text( $app__text[ 'string' ][ 52 ] );
    $( '#overview-comments' ).html( '<article>' + $app__text[ 'string' ][ 28 ] + '</article>' );
    $( '#overview-articles' ).html( '<article>' + $app__text[ 'string' ][ 29 ] + '</article>' );
    $( 'a[href="#overview-comments"] span:eq(0)' ).html( $app__text[ 'string' ][ 58 ] );
    $( 'a[href="#overview-articles"] span:eq(0)' ).html( $app__text[ 'string' ][ 59 ] );
    $( '#app__overview > p' ).html( $app__text[ 'string' ][ 94 ] );
    $( '#app__interstitial span' ).html( $app__text[ 'string' ][ 99 ] );
    $( '#app__readonly small' ).html( $app__text[ 'string' ][ 103 ] );

/* Modal */

    $( '[data-action=dismiss]' ).text( $app__text[ 'string' ][ 4 ] );
    $( '[data-action=send]' ).text( $app__text[ 'string' ][ 11 ] );
    
    $( '.namechange-disabled' ).html( $app__text[ 'string' ][ 47 ] );
    
    $( '.namepin h3 span' ).text( $app__text[ 'string' ][ 81 ] );
    $( '.modal [data-namepin=cancel]' ).html( $app__text[ 'string' ][ 90 ] );
    $( '.modal [data-namepin=next]' ).html( $app__text[ 'string' ][ 91 ] );

    $( '.namepin .content-namepin-1 p:eq(0)' ).html( $app__text[ 'string' ][ 82 ] );
    $( '.namepin .content-namepin-1 p:eq(1) span' ).html( $app__text[ 'string' ][ 83 ] );

    $( '.namepin .content-namepin-2 [data-toggle=dropdown] span' ).text( $app__text[ 'string' ][ 79 ] );
    $( '.namepin .content-namepin-2 .dropdown-menu span:eq(0)' ).html( app__format_string( $app__text[ 'string' ][ 83 ] ) );
    $( '.namepin .content-namepin-2 .dropdown-menu span:eq(1)' ).html( $app__text[ 'string' ][ 97 ] );
    $( '.namepin .content-namepin-2 [data-namepin=forgot] span' ).text( $app__text[ 'string' ][ 98 ] );
    $( '.namepin .content-namepin-2 p:eq(0)' ).html( $app__text[ 'string' ][ 84 ] );
    $( '.namepin .content-namepin-2 small:eq(0)' ).html( $app__text[ 'string' ][ 85 ] );
    $( '.namepin .content-namepin-2 small:eq(1)' ).html( $app__text[ 'string' ][ 92 ] );
    $( '.namepin .content-namepin-2 small:eq(2)' ).html( $app__text[ 'string' ][ 86 ] );
    $( '.namepin .content-namepin-2 small:eq(3)' ).html( $app__text[ 'string' ][ 93 ] );

    $( '.namepin .content-namepin-3 p:eq(0)' ).html( $app__text[ 'string' ][ 87 ] );
    $( '.namepin .content-namepin-3 p:eq(1)' ).html( $app__text[ 'string' ][ 88 ] );
    $( '.namepin .content-namepin-3 p:eq(2)' ).html( $app__text[ 'string' ][ 89 ] );
    $( '#pswp__modal .pswp__counter' ).text( $app__text[ 'string' ][ 96 ] );

/* Form */

    $('form.form-feedback label[for=name] small').text( $app__text[ 'string' ][ 17 ] );
    $('form.form-feedback label[for=text] small').text( $app__text[ 'string' ][ 19 ] );
    $('form.form-feedback label[for=mail] small').text( $app__text[ 'string' ][ 21 ] );

    $('form.form-feedback #name').attr('placeholder', $app__text[ 'string' ][ 18 ] );
    $('form.form-feedback #text').attr('placeholder', $app__text[ 'string' ][ 20 ] );
    $('form.form-feedback #mail').attr('placeholder', $app__text[ 'string' ][ 22 ] );

      if ( $app__settings[ 'local' ][ 'debug' ] === true ) {

        $( 'form.form-feedback .meta' ).removeClass( 'd-none' );

      }

/* Menu */

    $( '[data-menu=1] span' ).text( $app__text[ 'string' ][ 23 ] );
    $( '[data-menu=2] span' ).text( $app__text[ 'string' ][ 24 ] );
    $( '[data-menu=3] span' ).text( $app__text[ 'string' ][ 25 ] );
    $( '[data-menu=4] span:eq(0)' ).text( $app__text[ 'string' ][ 38 ] );
    $( '[data-menu=5] span:eq(0)' ).text( $app__text[ 'string' ][ 26 ] );
    $( '[data-menu=6] span:eq(0)' ).text( $app__text[ 'string' ][ 49 ] );
/*  $( '[data-menu=7] span:eq(0)' ).text( $app__text[ 'string' ][ 57 ] ); */
    $( '[data-menu=8] span:eq(0)' ).text( $app__text[ 'string' ][ 50 ] );
    $( '[data-menu=9] span:eq(0)' ).text( $app__text[ 'string' ][ 31 ] );
    $( '[data-menu=10] span:eq(0)' ).text( $app__text[ 'string' ][ 37 ] );
    $( '[data-menu=11] span:eq(0)' ).text( $app__text[ 'string' ][ 100 ] );
    $( '[data-menu=12] span:eq(0)' ).text( $app__text[ 'string' ][ 102 ] );

/* Personal */

    $( '#app__personal .dropdown-menu > div:first-of-type h5' ).text( $app__text[ 'string' ][ 74 ] );
    $( '#app__personal .dropdown-menu > div:last-of-type h5' ).text( $app__text[ 'string' ][ 76 ] );

/* :after labels */

    var $app__strings_style = $( '<style id="app__strings">' +
          '.app__content .comments .user-actions i[class*=reply]:after{ content: "' + $app__text[ 'string' ][ 44 ] + '";}' +
          '.app__content .comments .user-actions i[class*=edit]:after{ content: "' + $app__text[ 'string' ][ 45 ] + '";}' +
          '.app__content .comments .user-actions i[class*=thumb]:after{ content: "' + $app__text[ 'string' ][ 32 ] + '";}' +
          '.app__content .comments .user-actions i[class*=close]:after{ content: "' + $app__text[ 'string' ][ 105 ] + '";}' +
          /* '.app__content .comments .user-actions i[class*=close].fired:after{ content: "' + $app__text[ 'string' ][ 106 ] + '";}' + */
        '</style>' );

    $app__strings_style.appendTo( 'head' );

    setTimeout( function() {
      
      $( 'body' ).removeClass( 'initializing' );
      app__start();

    }, 500 );

  } catch( $app__error ) {

    app__error( 'app__initialize#01', 1, $app__error );

  }

}

/* ######################################################
  02. Start the app [visual - set text, images]
###################################################### */

window.app__start = function app__start() {

  try {

/* Reset time and basic app-vars */

    $app__refresh_start = Math.floor( Date.now() / 1000 );
    $app__connection_error = -1;

    app__cmd( 'app__data : local-settings fetched\n   >    $app__settings[ \'local\' ];', 1 );
    
    window.scrollTo( 0, 0 );
    $( 'html' ).addClass( 'no-flow' );

/* Get background images, show splashscreen [with image] */

    app__headers();
    app__progress( 1 );

    setTimeout( function() {

      $( '#app__splash' ).removeClass( 'invisible' );
      app__progress( 25 );

    }, 100 );

/* Get all available user settings */

    app__storage();

/* Get unique user #ID */

    app__user_id_get()

/* Footer meta-data [non static strings] */

    $( 'footer [data-year]' ).text( ( new Date() ).getFullYear() );

/* User name and pin > create once / always update */
      
    var $app__user_name = $app__user_creds = '';
    var $app__user_name_tmp = app__user_get( 'name' );
    var $app__user_creds_tmp = app__user_get( 'pin' );

    if ( $app__user_name_tmp !== '' && parseInt( $app__user_name_tmp ) !== -1 ) {
      
      $app__user_name = app__format_string( $app__user_name_tmp );

      if ( $app__user_creds_tmp !== '' && parseInt( $app__user_creds_tmp ) !== -1 ) {

        $app__user_creds = app__format_string( $app__user_creds_tmp );

/* Show credentials in the feedback-form */

        $( '#app__pin' ).removeClass( 'd-none' ).addClass( 'd-block' ).
            find( 'span:first-of-type b' ).text( $app__text[ 'string' ][ 78 ] ).end().
            find( 'span:last-of-type' ).html(  '<b> : ' + $app__user_creds + '</b> ' + $app__text[ 'string' ][ 101 ] );

/* Show credentials in the footer */

        $app__user_creds = '(' + $app__text[ 'string' ][ 78 ] + ' : ' + $app__user_creds + ')';

      }

      if ( !$( 'footer .dropdown-menu [data-user]' ).length ) {

        $( 'footer .dropdown-menu' ).append(

          '<span class="d-block border-top py-1 mt-1" data-user><b class="text-truncate d-block">' + $app__user_name + '</b>' + $app__user_creds + '</span>'

        );

      } else {

        $( 'footer .dropdown-menu [data-user]' ).html(

          '<b class="text-truncate d-block">' + $app__user_name + '</b>' + $app__user_creds

        );

      }

    }

/* Show update-message [ higher importance than message in modal ] */

    app__check_version();

/* App is dressed up, load settings from server */

    app__ini_load();

  } catch( $app__error ) {

    app__error( 'app__initialize#02', 1, $app__error );

  }

}

/* ######################################################
  03. Load ini-settings from server
###################################################### */

function app__ini_load() {

  try {

/* Fetch ini-settings from the server */

    var $app__api = 'ini';
    $app__url = $app__settings[ 'local' ][ 'api' ] + $app__api;

    app__cmd( 'app__initialize : loading > ' + $app__url );

    $.ajax({

      method: 'get',
      url: $app__url,
      cache: false,
      dataType: 'text',
      complete: function() {

/* 2DO */

      },
      success: function( $app__response, $app__text, $app__xhr ) {

        app__cmd( '', 1 );
        app__cmd( 'app__initialize : remote-settings fetched\n   >    $app__settings[ \'remote\' ];', 1 );

        try {

          $app__settings[ 'remote' ] = JSON.parse( $app__response );

        } catch( $app__error ) {

          app__error( 'app__initialize#03A', 1, $app__error );

        }

        app__progress( 50 );
        app__ini_parse();

      },
      error: function( $app__xhr, $app__text, $app__error ) {

        app__error( 'app__initialize#03B', 1, JSON.stringify( $app__xhr ) );

      }

    });

  } catch( $app__error ) {

    app__error( 'app__initialize#04', 1, $app__error );

  }

}

/* ######################################################
  04. Parse the server-settings
###################################################### */

function app__ini_parse() {

  try {

/* Check if a message must be shown by #ID [ message #ID ] */

    $app__message[ 'id' ] = $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'message' ][ 'id' ];

    var $app__message_last = parseInt( $app__settings[ 'user' ][ 'message' ] );
    var $app__message_this = parseInt( $app__message[ 'id' ] );

    app__cmd( 'app__initialize : message version > ' + $app__message_last + ' | ' + $app__message_this, 1 );

/* New version detected -> show message and update local version */

      if ( $app__message_last !== $app__message_this && $app__message_this !== -1 || $app__message_this === 0 ) {

        app__message_show( $app__message_this );

      }

/* -----------------------------------------------------
  See if app is allowed to start [message already set]
----------------------------------------------------- */

      $app__killswitch = 'false';

      if ( $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'status' ].hasOwnProperty( 'killswitch' ) ) {

        $app__killswitch = $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'status' ][ 'killswitch' ];

      }

      if ( $app__killswitch === 'true' ) {

        alert( 'Error - app terminated.' );

/* 2DO : hide splash, kill processes */

      } else {

/* -----------------------------------------------------
  Parse local- and update-time
----------------------------------------------------- */

      app__time_local();
      app__time_updated();

/* -----------------------------------------------------
  See if name-change is allowed one more time
----------------------------------------------------- */

      $app__namechange = -1;
      
      if ( $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'status' ].hasOwnProperty( 'namechange' ) ) {
      
        var $app__namechange_tmp = parseInt( $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'status' ][ 'namechange' ] );

        if ( !isNaN( $app__namechange_tmp ) ) {

          $app__namechange = $app__namechange_tmp;

        }

      if ( $app__namechange > 0 && $app__settings[ 'user' ][ 'namechange' ] < 1 ) {

        if ( $app__namechange > $app__settings[ 'local' ][ 'namechange' ] ) {

          $app__namechange = $app__settings[ 'local' ][ 'namechange' ];

        }

        app__user_set( 'namechange', '' + $app__namechange );

      }

    }

/* -----------------------------------------------------
  Check if app is set to readonly [server, not user]
----------------------------------------------------- */

      $app__readonly = -1;

      $( 'html' ).removeClass( 'readonly' );

      if ( $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'status' ].hasOwnProperty( 'readonly' ) ) {
        
        var $app__readonly_tmp = parseInt( $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'status' ][ 'readonly' ] );

        if ( !isNaN( $app__readonly_tmp ) ) {

          $app__readonly = $app__readonly_tmp;

          if ( $app__readonly_tmp === 1 ) {
            
            $( 'html' ).addClass( 'readonly' );

          }

        }

      }

/* -----------------------------------------------------
  Check if namepin is required by server
----------------------------------------------------- */

      $app__namepin = -1;

      if ( $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'status' ].hasOwnProperty( 'namepin' ) ) {

        var $app__namepin_tmp = parseInt( $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'status' ][ 'namepin' ] );

        if ( !isNaN( $app__namepin_tmp ) ) {

          $app__namepin = $app__namepin_tmp;

        }

      }

/* -----------------------------------------------------
  Check if special interstitial must be shown
----------------------------------------------------- */

      $app__interstitial = -1; /* ad is not needed */
      $app__interstitial_show = -1; /* ad should not be shown */

      if ( $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'status' ].hasOwnProperty( 'interstitial' ) ) {

        var $app__interstitial_tmp = parseInt( $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'status' ][ 'interstitial' ] );
        
        if ( !isNaN( $app__interstitial_tmp ) ) {

          $app__interstitial = $app__interstitial_tmp;
    
        }

      }

      setTimeout( function() {

        if ( $app__ua_android === true && typeof app__ad_show === 'function' ) {

          app__ad_show();

        }

      }, 1000 );

      app__cmd( 'app__initialize : interstitial > remote ' + $app__interstitial + ' | local ' + parseInt( $app__settings[ 'user' ][ 'interstitial' ] ), 1 );

/* -----------------------------------------------------
  Check how all images are server [local | api | source]
----------------------------------------------------- */

      if ( $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'image' ].hasOwnProperty( 'api_xs' ) ) {
    
        $app__image_api_xs = $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'image' ][ 'api_xs' ];
  
      }
      
      if ( $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'image' ].hasOwnProperty( 'api_xl' ) ) {
      
        $app__image_api_xl = $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'image' ][ 'api_xl' ];
  
      }
  
      app__cmd( 'app__initialize : image served > XS ' + $app__image_api_xs + ' | XL ' + $app__image_api_xl, 1 );

/* -----------------------------------------------------
  Check settings for the comments
----------------------------------------------------- */

/* STARRED */

      if ( $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'status' ].hasOwnProperty( 'starred' ) ) {
        
        var $app__comment_starred_tmp = parseInt( $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'status' ][ 'starred' ] );

        if ( !isNaN( $app__comment_starred_tmp ) ) {

          $app__comment_starred = $app__comment_starred_tmp;

        }

      }

/* HIDDEN */

      if ( $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'status' ].hasOwnProperty( 'comment_hide' ) ) {
        
        var $app__comment_hide_tmp = parseInt( $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'status' ][ 'comment_hide' ] );

        if ( !isNaN( $app__comment_hide_tmp ) ) {

          $app__comment_hide = $app__comment_hide_tmp;

        }

      }

      if ( $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'status' ].hasOwnProperty( 'comment_hide_auto' ) ) {
        
        var $app__comment_hide_auto_tmp = parseInt( $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'status' ][ 'comment_hide_auto' ] );

        if ( !isNaN( $app__comment_hide_auto_tmp ) ) {

          $app__comment_hide_auto = $app__comment_hide_auto_tmp;

        }

      }

/* -----------------------------------------------------
  All clear > load the news
----------------------------------------------------- */

      app__news_load();

    }

  } catch( $app__error ) {

    app__error( 'app__initialize#05', 1, $app__error );

  }

}

/* ######################################################
  05. Create a message-box [when needed]
###################################################### */

/* -----------------------------------------------------
  Show the message in a box, or modal
----------------------------------------------------- */

function app__message_show( $app__message_this ) {

  try {

/* Get the message-data */

    $app__message[ 'title' ] = $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'message' ][ 'title' ];
    $app__message[ 'icon' ] = $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'message' ][ 'icon' ];
    $app__message[ 'text' ] = app__format_string( $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'message' ][ 'text' ], 2 );
    $app__message[ 'type' ] =  $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'message' ][ 'type' ];
    $app__message[ 'intent' ] = $app__settings[ 'remote' ][ 'ini' ][ 0 ][ 'message' ][ 'intent' ];

      if ( $app__message[ 'icon' ] !== '' && $app__message[ 'icon' ] !== -1 ) {

        $app__message[ 'title' ] = '<i class="zmdi zmdi-' + $app__message[ 'icon' ] + ' mr-2"></i> ' + $app__message[ 'title' ];

      }

/* Show message-box [alert] > when only .alert-secondary is present [ not the more important .alert-danger ] */

    if ( $app__message[ 'type' ] === 'box' ) {

      var $app__message_box = $( '.alert-secondary' );

      $app__message_box.
        addClass( 'd-none bg-brand-dark text-white' ).
        removeAttr( 'data-error' ).
        attr( 'data-message', $app__message_this ).
        find( 'h3' ).html( $app__message[ 'title' ] ).
        next( 'p' ).html( '<span data-intent>' + $app__message[ 'text' ] + '</span>' ).
        parent().removeClass( 'd-none' );

/* Show message-box [modal] */

    } else if ( $app__message[ 'type' ] === 'modal' && !$( '.modal-message.update' ).length ) {

      $( '.modal' ).
        addClass( 'modal-message notification' ).
        find( '.modal-title' ).html( $app__message[ 'title' ] ).
        parent().next( '.modal-body' ).find( '.notification' ).html( '<span data-intent>' + $app__message[ 'text' ] + '</span>' );
      
      $( '.modal' ).modal();

    }

/* -----------------------------------------------------
  Hide message and save #ID
----------------------------------------------------- */

    $( '.alert [data-dismiss], .modal-message.notification [data-dismiss]' ).on( 'click', function() {
      
      if ( !$( this ).parent().hasClass( 'alert-danger' ) ) {

        app__user_set( 'message', '' + $app__message[ 'id' ] );

        if ( $( this ).hasClass( 'close' ) ) {

          $( '.alert-secondary' ).addClass( 'd-none' );
          $( '[data-toggle=tooltip]' ).tooltip( 'update' );
          
          return false;

        }

      }

  } );

/* -----------------------------------------------------
  Attach action to message
----------------------------------------------------- */

    if ( $app__message[ 'intent' ] != '' && $app__message[ 'intent' ] != -1 ) {

      $( '[data-intent]' ).on( 'click', function() {

/* Try to fetch any variable for the attached function */

      $app__message[ 'vars' ] = '';

        if ( $app__message[ 'intent' ].indexOf( '|' ) != -1 ) {

          $app__message[ 'vars' ] = $app__message[ 'intent' ].substring( $app__message[ 'intent' ].indexOf( '|' ) + 1 );
          $app__message[ 'function' ] = $app__message[ 'intent' ].substring( 0, $app__message[ 'intent' ].indexOf( '|' ) );

        } else {

          $app__message[ 'function' ] = $app__message[ 'intent' ];

        }

        app__message_intent();

      } );

    }

    if ( parseInt( $app__message[ 'id' ] ) === 0 ) {

      $( '.alert.alert-dismissible.alert-secondary .close' ).hide();

    }

  } catch( $app__error ) {

    app__error( 'app__initialize#06', 1, $app__error );

  }

}

/* -----------------------------------------------------
  Execute any action, binded to the message
----------------------------------------------------- */

function app__message_intent() {

  try {

    app__cmd( $app__message[ 'function' ] + '( "' + $app__message[ 'vars' ] + '" )', 1 );

    window[ $app__message[ 'function' ] ]( $app__message[ 'vars' ] );

  } catch( $app__error ) {

/* 2DO */

  }

}

/* ######################################################
  06. Update the progressbar [splashscreen]
###################################################### */

/* -----------------------------------------------------

  Possible events
    
    001 : initialize [app]
    025 : app loaded [assets]
    050 : settings loaded [server]
    075 : news-feed loaded [server]
    100 : news-feed parsed [local]

----------------------------------------------------- */

window.app__progress = function app__progress( $app__progress ) {

  try {

    var $app__progress = parseInt( $app__progress );
    var $app__progress_bar = $( '#app__splash .progress-bar' );

    setTimeout( function() {

      $app__progress_bar.addClass( 'progress-bar-animated' ).css({

        'width': $app__progress + '%',
        'opacity': 100

      });

/* Reload is detected > hide content, show splash */

      if ( $app__progress === 1 ) {

        $( 'body' ).addClass( 'loading' );
        $( '#app__splash' ).show().find( '.progress-bar' ).css( { 'opacity': 0 } );

      }

/* Initialize the logo and progressbar */

      if ( $app__progress === 25 ) {

        setTimeout( function() {

          $( '#app__splash' ).find( 'img' ).removeClass( 'rounded-circle' );

        }, 250 );

      }

/* Loading is done > hide splash, show content */

      if ( $app__progress === 100 ) {

/* 1#5 > poll : render the poll */

        app__poll_fetch();

/* 2#5 > overview [recent] : render recent */

        app__overview_recent_fetch();

        if ( $( '#app__overview' ).length ) {

/* 3#5 > overview [populair] : render populair */

          app__overview_populair_fetch();

        }

/* 4#5 > discussion : render and show */

        app__discussion_fetch();

/* 5#5 > personal : validate | fetch bookmarks and comments */

        app__personal_bookmarks_fetch();
        app__personal_comments_fetch();

        if ( $app__settings[ 'local' ][ 'debug' ] !== true ) {

          $app__news_data = '';
          $app__news = [];

        }

        setTimeout( function() {

/* Fire the fallback-statistics */

          app__stats_fallback();

/* Tooltips [get and set] */

/*

  BOOTSTRAP > 4.3.1 ~ if ( $app__ua_android_version !== 4 ) { ... }

  bug conditions  >       android 4 | app >= 5.2.0 | never commented
  POPPER          >       1.14.3
  BOOTSTRAP       >       4.3.1 [ not bundled, not POPPER 1.14.7 ]

*/
          
          app__tooltips();

/* Show news-list */

          $( 'html' ).removeClass( 'no-flow' );
          $( 'body' ).removeClass( 'loading' );
          $( '#app__splash' ).addClass( 'no-image' ).hide();
          $app__progress_bar.removeClass( 'progress-bar-animated' );

          window.scrollTo( 0, 0 );

/* Auto-resume is allowed now */

          $app__refresh_allowed = 1;

/* Initialize the header-menu */

          $( '#navbar-nav li a, #app__news ol' ).removeClass( 'active' );
          $( '#navbar-nav ol:eq( 0 ) li:eq( 0 ) a' ).addClass( 'active' );
          $( '#navbar-nav ol:eq( 0 )' ).prepend( '<li class="position-absolute d-none"><img src="app/images/app.png" class="ml-md-0 rounded cursor-pointer" id="app__brand"></li>' );

/* When an update-message is shown, animate the smiley */

          if ( $( '.modal.update i.zmdi.zmdi-mood' ).length ) {

            setTimeout( function() {

              $( '.modal.update i.zmdi.zmdi-mood' ).addClass( 'animate_bounce' );

            }, 1000 ); 

          }

/* Prepare to load the thumbnails afterwards, when needed */

            setTimeout( function() {

              if ( $app__settings[ 'user' ][ 'images_hide' ] !== true ) {

                app__thumbnails_parse( -1 ); /* -1 : parse all [visible] thumbs */

              }

              setTimeout( function() {

                $( '#app__news ol#app__source_01' ).addClass( 'active' );

              }, 500 );

            }, 500 );
  
          app__cmd( '',  1 );

        }, 1000 );

      }

      app__cmd( 'app__initialize : progress > ' + $app__progress + '%', 1 );

    }, parseInt( $app__progress ) * 5 );

  } catch( $app__error ) {

    app__error( 'app__initialize#07', 1, $app__error );

  }

}

/* ######################################################
  07. Set the header images [random]
###################################################### */

function app__headers() {

  try {

    var $app__headers_array = [];
    var $app__headers_images = $app__settings[ 'local' ][ 'images' ];
    var $app__headers_total = $app__settings[ 'local' ][ 'sources' ];
    var $app__headers_style = '';

/* Check for minimal requirements */

    if ( $app__headers_images < $app__headers_total ) {

      if ( $app__settings[ 'local' ][ 'debug' ] === true ) {

        alert( 'Error - less images than headers.\r\n-- app__initialize' );

      }

      return;

    }

/* All is well */

    while( $app__headers_array.length < $app__headers_total ) {

      var $app__headers_random = app__format_number ( Math.ceil( Math.random() * $app__headers_images ) );
      var $app__headers_id = false;

        for ( var $app__headers_index = 0; $app__headers_index < $app__headers_array.length; $app__headers_index++ ) {

        	if ( $app__headers_array[ $app__headers_index ] === $app__headers_random ) {

        	    $app__headers_id = true;
              break;

          }

        }

      if ( !$app__headers_id ) {

        $app__headers_array[ $app__headers_array.length ] = $app__headers_random;

        var $app__headers_break = $app__headers_index < $app__headers_total ? '\n' : '';

          if ( $app__headers_index === 0 ) {

            $app__headers_style += '#app__splash:before { background-image: url("app/images/headers/header_' + $app__headers_random + '.jpg"); }' + $app__headers_break;
            $( '#app__splash' ).removeClass( 'no-image' );

          }

        var $app__headers_id = $app__headers_index + 1;

          if ( $app__headers_id < 10 ) {

            $app__headers_id = '0' + $app__headers_id;

          }

        $app__headers_style += '#app__news > ol[data-src="' + $app__headers_id + '"] h2 { background-image: url("app/images/headers/header_' + $app__headers_random + '.jpg"); }' + $app__headers_break;

        app__cmd( 'app__initialize : header ' + ( $app__headers_index + 1 ) + ' > #' + $app__headers_random );

          if ( $app__headers_index + 1 == $app__headers_total ) {

            app__cmd( '', 1 );

          }

      }

    }

    $app__headers_style = $( '<style id="app__headers">' + $app__headers_style + '</style>' );
    $app__headers_style.appendTo( 'head' );

  } catch( $app__error ) {

    app__error( 'app__initialize#08', 1, $app__error );

  }

}

/* ######################################################
  08. Check [and set] user-agent css-classes
###################################################### */

function app__device_version( $app__ua ) {

  try {

    var match = $app__ua.match( /android\s([0-9\.]*)/ );
    return match ? match[ 1 ] : false;

  } catch( $app__error ) {

    app__error( 'app__initialize#09', 1, $app__error );

  }

};

function app__device() {

  try {

  var $app__ua = navigator.userAgent.toLowerCase();

/* Check if Android [any] is active */

    $app__ua_android = ( /(android)/i.test( navigator.userAgent ) );

    if ( $app__ua_android ) {

      $app__ua_android_version = parseInt( app__device_version( $app__ua ), 10 );

    }
    
/* Check if Windows 10 Mobile is active [ not WP8.x ] */

    $app__ua_w10m = (

      $app__ua.indexOf( 'windows' ) > -1 &&
      $app__ua.indexOf( 'phone' ) > -1 &&
      $app__ua.indexOf( 'iemobile/10' ) > -1

    );

/* Fetch results */

    app__cmd( '', 1 );
    app__cmd( 'app__initialize : UA > ' + navigator.userAgent );

    if ( $app__ua_w10m ) {

      $app__ua_android = $app__ua_android_version = false;
      $( 'html' ).addClass( 'app__ua_w10m' );

    }

    if ( $app__ua_android ) {

      $( 'html' ).addClass( 'app__ua-android-' + $app__ua_android_version );

    }

  } catch( $app__error ) {

    app__error( 'app__initialize#10', 1, $app__error );

  }

}

/* ######################################################
  09. Restart the app
###################################################### */

window.app__restart = function app__restart() {

  try {

    app__cmd( '[clear]', 1 );
    app__cmd( 'app__initialize : tombstone status #' + $app__refresh_tombstoned, 1 );

/* Show splash */

    setTimeout( function() {

      app__progress( 1 );

      setTimeout( function() {

/* Unbind all linked actions, preserve some */

        $( 'body' ).find( '[data-unbind], [data-unbind] *' ).each( function() {

          $( this ).off();

        });

/* Reset content - photomodal */

        if ( $( '.pswp-open' ).length ) {
      
          try {

            if ( $app__pswp_gallery !== 'undefined' && $app__pswp_gallery !== null ) {

              $app__pswp_gallery.close();

            }

          } catch( $app__error ) {

            app__error( 'app__initialize#11A', 1, $app__error );
      
          }

        }

/* Reset content - menu */

        if ( $( '.menu-open' ).length ) {

          try {

            $( 'button[data-toggle=offcanvas]' ).trigger( 'click' );

          } catch( $app__error ) {

            app__error( 'app__initialize#11B', 1, $app__error );
      
          }

        }

/* Reset content - various */

        $( '#app__splash' ).attr( 'style' , '' );
        $( '.alert' ).addClass( 'alert-secondary d-none' ).removeClass( 'alert-danger visible position-fixed container' ).removeAttr( 'data-error' );
        $( '[data-toggle=tooltip]' ).tooltip( 'dispose' );
        $( '.modal' ).modal( 'hide' );
        $( '#app__headers' ).remove();
        $( '#app__news, #navbar-nav ol:eq( 0 )' ).html( '' );
        $( '#app__overview .active' ).removeClass( 'active show' );
        $( '#app__overview .btn-dark' ).addClass( 'btn-brand-dark' );
        $( '#app__backkey' ).removeClass( 'd-none' ).hide();

/* New start */

        app__start();

      }, 50 );

    }, 50 );

  } catch( $app__error ) {

    app__error( 'app__initialize#11C', 1, $app__error );

  }

}

$( 'body' ).on( 'click', '[data-action=restart]', function( $app__event ){

  try {

    $app__event.preventDefault();
    app__restart();

  } catch( $app__error ) {

    app__error( 'app__initialize#12', 1, $app__error );

  }

});

/* ######################################################
  10. Check app-version [show update message]
###################################################### */

function app__check_version() {

  try {

    var $app__update_last = $app__settings[ 'user' ][ 'version' ];
    var $app__update_this = $app__settings[ 'local' ][ 'version' ];

    $( 'html' ).attr( 'id', 'app__v' + $app__update_this.replace( /[^0-9]/gi, '' ) );

    app__cmd( 'app__initialize : app version > ' + $app__update_last + ' | ' + $app__update_this, 1);

/* New version detected -> update local version */

    if ( $app__update_last !== $app__update_this ) {

      app__user_set( 'version', '' + $app__update_this );

/* New version detected -> show message when it's not a fresh install */

      if ( parseInt( $app__update_last ) !== -1 ) {

        $( '.modal' ).
          addClass( 'modal-message update' ).
          find( '.modal-title' ).html( $app__text[ 'string' ][ 33 ] ).parent().find( '.modal-title span' ).html( $app__update_this ).
          closest( '.modal-header' ).next( '.modal-body' ).find( '.update' ).html(

            $app__settings[ 'local' ][ 'update' ] + '<span class="text-muted d-block">' + $app__text[ 'string' ][ 36 ] + '</span>'

          );
          
        $( '.modal' ).modal();

      }

    }

  } catch( $app__error ) {

    app__error( 'app__initialize#13', 1, $app__error );

  }

}

/* ######################################################
  11. Get | set the unique user #ID
###################################################### */

function app__user_id_set( $app__length, $app__pool ) {

  try {

    var $app__key = '';

      for ( var $app__i = $app__length; $app__i > 0; -- $app__i ) {

        $app__key += $app__pool[ Math.floor( Math.random() * $app__pool.length ) ];

      }

    return $app__key;

  } catch( $app__error ) {

    app__error( 'app__initialize#14', 1, $app__error );

  }

}

function app__user_id_get() {

  try {

    var $app__user_id = $app__settings[ 'user' ][ 'id' ];

      if ( $app__user_id == '' || $app__user_id.length < 40 ) {

        var $app__date = new Date();

        $app__user_id = $app__date.getFullYear() + ( '0' + ( $app__date.getMonth() + 1 ) ).slice( -2 ) + ( '0' + $app__date.getDate() ).slice( -2 );
        $app__user_id += '-' + app__user_id_set( 32, '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ' );

        app__user_set( 'id', $app__user_id );

      };
    
    $( 'form.form-feedback #user' ).val( $app__user_id );

  } catch( $app__error ) {

    app__error( 'app__initialize#15', 1, $app__error );

  }

}

/* -----------------------------------------------------
  Catch me if you can
----------------------------------------------------- */

  app__cmd( 'app__initialize : script loaded' );

} catch ( $app__error ) {

  app__error( 'app__initialize#00', 1, $app__error.message );

} }( jQuery ));