/* ======================================================

  T.O.C. [table of contents]

  01. Toggle the hamburger-menu
  02. Checkbox | toggle functions
  03. Jump to a news-source
  04. Send feedback
  05. Close menu for specific menu-items
  06. Fire the comments-order toggle
  07. Promote (rate) app
  08. Promote (share) app
  09. Close menu by icon
  10. Show source-info (external)

====================================================== */

;(function ( $ ) { try {

/* ######################################################
  01. Toggle the hamburger menu
###################################################### */

/* Toggle the menu */

$( '[data-toggle=offcanvas]' ).on( 'click', function () {

  try {

    if ( !$('.menu-open').length ) {

      app__no_scroll( 1 );

    } else {

      app__no_scroll( -1 );

    }
    
    $( '#app__brand' ).fadeOut( 0 ).fadeIn( 1000 );
    
    setTimeout( function() {
  
      $( '#app__brand' ).toggleClass( 'animate_bounce' );
  
    }, 1000 );
  
    $( 'body' ).toggleClass( 'menu-open' );
    $( this ).toggleClass( 'collapsed' );
    $( '.offcanvas-collapse' ).toggleClass( 'open' );
  
  } catch( $app__error ) {

    app__error( 'app__menu#01', 10, $app__error );

  }

});

/* ######################################################
  02. All checkbox | toggle functions
###################################################### */

$( ':checkbox' ).on( 'change', function() {

  try {

    $app__setting = $( this ).attr( 'id' );

    app__user_set( $app__setting, $( this ).prop( 'checked' ) );

      if ( $( this ).prop( 'checked' ) === true ) {

        $( 'html' ).addClass( 'settings-' + $app__setting );

      } else {

        $( 'html' ).removeClass( 'settings-' + $app__setting );

/* Uncheck smaller-fonts, when small-fonts is unchecked */

        if ( $app__setting === 'fonts_small' ) {

          $( '#fonts_smaller' ).prop( 'checked', false ).change();

        }

      }

  } catch( $app__error ) {

    app__error( 'app__menu#02', 10, $app__error );

  }

});

/* ######################################################
  03. Jump to a news-source
###################################################### */

$( 'body' ).on( 'click', '#navbar-nav ol:eq( 0 ) a', function( $app__event ) {

  try {

    $app__event.preventDefault();

    if ( !$( '.menu-open' ).length ) {
      
      var $app__scroll_to = $( $( this ).attr( 'href' ) );

      if ( $app__scroll_to.length ) {

        $( 'html, body' ).animate( {
    
          scrollTop: Math.floor( $app__scroll_to.offset().top - $( '.navbar' ).outerHeight() )
    
        }, 750 );
      
      }
      
    }

  } catch( $app__error ) {

    app__error( 'app__menu#03', 10, $app__error );

  }

});

/* ######################################################
  04. Send mail | feedback
###################################################### */

window.app__prepare_mail = function app__prepare_mail() {

  try {

    $app__feedback_id = Date.now();

/* Meta-data, not used - but required */

    $( 'form.form-feedback #time' ).val( $app__feedback_id );
    $( 'form.form-feedback #file' ).val( -1 );
    $( 'form.form-feedback #item' ).val( app__format_string( $app__text[ 'string' ][ 0 ] ) );
    $( 'form.form-feedback #reply' ).val( -1 );
    $( 'form.form-feedback #level' ).val( 0 );  
    $( 'form.form-feedback #pin' ).val( $app__settings[ 'user' ][ 'pin' ] );
    $( '.modal' ).addClass( 'modal-feedback mail' ).find( '.modal-title' ).text( $app__text[ 'string' ][ 30 ] ).end().modal();
    $( 'form.form-feedback #mail' ).val( '' );

  } catch( $app__error ) {

    app__error( 'app__menu#04A', 10, $app__error );

  }

}

$( '[data-action=mail]' ).on( 'click', function() {

  try {

    setTimeout( function() {

      app__prepare_mail();

    }, 250 );

  } catch( $app__error ) {

    app__error( 'app__menu#04B', 10, $app__error );

  }

} );

/* ######################################################
  05. Auto-close menu for specific menu-items
###################################################### */

$( 'nav [data-action=mail], nav [data-action^=promote-]' ).on( 'click', function( $app__event ) {

  try {

    $app__event.preventDefault();
    $( '.navbar-toggler' ).trigger( 'click' );

  } catch( $app__error ) {

    app__error( 'app__menu#05', 10, $app__error );

  }

} );

/* ######################################################
  06. Fire the comments-order toggle
###################################################### */

$( '#comments_order:checkbox' ).on( 'change', function( $app__event ) {

  try {

    $app__event.preventDefault();

/* Only execute when there are comments to be parsed */

    if ( $( 'ol.comments' ).length ) {

      app__order_comments();

    }

  } catch( $app__error ) {

    app__error( 'app__menu#06', 10, $app__error );

  }

});

/* ######################################################
  07. Promote (rate) the app
###################################################### */

$( 'body' ).on( 'click', '[data-action=promote-rate]', function( $app__event ) {

  try {
    
    $app__event.preventDefault();
    app__rate();

  } catch( $app__error ) {

    app__error( 'app__menu#07A', 10, $app__error );

  }

} );

window.app__rate = function app__rate() {

  try {

    if ( $app__ua_android === true ) {

      app__browse( $app__settings[ 'local' ][ 'store-url' ], 3 );

    } else {

      app__browse( $app__settings[ 'local' ][ 'url-store' ] );

    }

  } catch( $app__error ) {

    app__error( 'app__menu#07B', 10, $app__error );

  }

}

/* ######################################################
  08. Promote (share) the app
###################################################### */

$( '[data-action^=promote-]' ).on( 'click', function() {

  try {

    app__promote( $( this ).attr( 'data-action' ) );

  } catch( $app__error ) {

    app__error( 'app__menu#08A', 10, $app__error );

  }

} );

window.app__promote = function app__promote( $app__promote_type ) {

  try {

    switch ( $app__promote_type ) {

      case 'promote-mail':

        // app__mail( $app__text[ 'string' ][ 28 ], $app__text[ 'string' ][ 29 ] );
        app__browse( $app__settings[ 'local' ][ 'url-email' ] );

      break;

      case 'promote-facebook':
  
        app__browse( $app__settings[ 'local' ][ 'url-facebook' ] );

      break;

      case 'promote-twitter':
  
        app__browse( $app__settings[ 'local' ][ 'url-twitter' ] );

      break;

      case 'promote-whatsapp':

        app__browse( $app__settings[ 'local' ][ 'url-whatsapp' ] );

      break;

    }

  } catch( $app__error ) {

    app__error( 'app__menu#08B', 10, $app__error );

  }

}

/* ######################################################
  09. Close meny by icon
###################################################### */

$( 'body' ).on( 'click', '#app__brand', function( $app__event ) {

  try {

    $app__event.preventDefault();

    if ( $( '.menu-open' ).length ) {
  
      $( 'button[data-toggle=offcanvas]' ).trigger( 'click' );
    
    }

  } catch( $app__error ) {

    app__error( 'app__menu#09', 10, $app__error );

  }

} );

/* ######################################################
  10. Show source-info
###################################################### */

$( '[data-action=source-info]' ).on( 'click', function( $app__event ) {

  try {

    $app__event.preventDefault();

    app__browse( $app__settings[ 'local' ][ 'url-sources' ] );

  } catch( $app__error ) {

    app__error( 'app__menu#10', 10, $app__error );

  }

} );

/* -----------------------------------------------------
  Catch me if you can
----------------------------------------------------- */

app__cmd( 'app__menu : script loaded' );

} catch ( $app__error ) {

  app__error( 'app__menu#00', 10, $app__error.message );

} }( jQuery ));