/* ======================================================

T.O.C. [table of contents]

01. Toggle the overview beviour
02. Fetch the recent reactions
03. Parse the reactions
04. Populate the populair articles
05. Create the populair articles
06. Fire the overview actions
07. Add images to the entries

====================================================== */

var $app__populair_data = [];
var $app__populair_html = '';
var $app__scroll_delay = 350; /* Matches default Bootstrap (collapse) timing in ms. */
var $app__scroll_delay_callback = 1;  /* Scroll to comment, don't jump [at default] */

;(function ( $ ) { try {

/* ######################################################
  01. Overview toggle-behaviour
###################################################### */

$( '#app__overview [data-toggle]' ).on( 'click', function() {

  try {

    $( '#app__overview .btn-dark' ).removeClass( 'btn-brand-dark' );

    if ( $( this ).hasClass( 'active' ) ) {

        $( '#app__overview .btn-dark' ).addClass( 'btn-brand-dark' );
      
      setTimeout( function() {

        $( '#app__overview .active' ).removeClass( 'active show' );

      }, 100 );

    }

    $( this ).blur();

  } catch( $app__error ) {

    app__error( 'app__overview#01', 14, $app__error );

  }

});

/* ######################################################
  02. Fetch the recent reactions
###################################################### */

window.app__overview_recent_fetch = function app__overview_recent_fetch() {

  try {

    if ( $app__news.hasOwnProperty( 'recent' ) ) {
      
      $app__recent = '<ul id="app__source_recent" class="list-unstyled"><li id="comments_recent"><article>';
      $app__recent += '<ol class="list-unstyled">' + $app__news[ 'recent' ][ 0 ][ 'comments' ] + '</ol>';
      $app__recent += '</article></li></ul>';

      $( '#app__overview #overview-comments' ).html( $app__recent );
      app__overview_recent_parse();

    } else {

      $( '#app__overview' ).remove();

    }

  } catch( $app__error ) {

    app__error( 'app__overview#02', 14, $app__error );

  }

}

/* ######################################################
  03. Parse the recent reactions
###################################################### */

function app__overview_recent_parse() {

  try {

    var $app__recent_count = 0;

    $( '#app__overview #overview-comments ol li' ).each( function() {

      if ( $( 'li[data-guid=' + $( this ).data( 'recent-guid' ) + ']' ).length ) {

        $( this ).attr( 'data-scroll-to', '' ).addClass( 'cursor-pointer' ).find( 'p a' ).addClass( 'text-secondary' ).end().find( 'p b' ).addClass( 'mention' );

/* Set title when subject is left empty by commenter [only old app versions] */

        if ( !$( 'h5', this ).text().length ) {

          var $app__recent_title = $( 'li[data-guid=' + $( this ).data( 'recent-guid' ) + '] h3' ).html();

          if ( $app__recent_title.length ) {

            $app__recent_title = app__format_string( $app__recent_title, 3 );

          } else {

            $app__recent_title = '- ? -';

          }

          $( 'h5', this ).text( $app__recent_title );

        }

        $app__recent_count++;

        if ( $app__settings[ 'local' ][ 'debug' ] === true ) {

          $( this ).attr( 'title',  ( $( 'li[data-guid=' + $( this ).data( 'recent-guid' ) + '] h3' ).is( ':visible' ) ? '[new] ' : '[archived] ' ) + $( this ).data( 'recent-guid' ) );

        }

      } else {

        $( this ).remove();

      }

    });

    if ( $app__recent_count < 1 ) {

      $( '#overview-comments' ).html( '<article>' + $app__text[ 'string' ][ 28 ] + '</article>' );

    }

  } catch( $app__error ) {

    app__error( 'app__overview#03', 14, $app__error );

  }

};

/* ######################################################
  04. Populate the populair articles
###################################################### */

window.app__overview_populair_add = function app__overview_populair_add( $app__key, $app__value ) {

  try {

    $app__populair_data.push( { key: $app__key, val: $app__value } );

  } catch( $app__error ) {

    app__error( 'app__overview#04', 14, $app__error );

  }

}

/* ######################################################
  05. Create the populair articles
###################################################### */

window.app__overview_populair_fetch = function app__overview_populair_fetch( $app__key, $app__value ) {

  try {

    $app__populair_data = $app__populair_data.sort( function( $app__value_a, $app__value_b ) {

      return $app__value_a.val - $app__value_b.val;

    } );

    $app__populair_data = $app__populair_data.reverse().slice( 0, 3 );

    if ( $app__populair_data.length ) {

      $.each( $app__populair_data, function( $app__key, $app__value ) {

        if ( parseInt( $app__value.val ) > 0 && $( 'li[data-guid=' + $app__value.key + ']' ).length ) {
          
          var $app__populair_comments = $app__value.val;
          var $app__populair_guid = $app__value.key;
          var $app__populair_title = $( 'li[data-guid=' + $app__value.key + '] h3' ).html();

            if ( $app__populair_title.length ) {

              $app__populair_title = app__format_string( $app__populair_title, 3 );

            } else {

              $app__populair_title = '- ? -';

            }

          var $app__populair_text = $( 'li[data-guid=' + $app__value.key + '] article .article' ).html();

            if ( $app__populair_text.length ) {

              $app__populair_text = app__format_string( $app__populair_text, 3 );

            } else {

              $app__populair_text = '- ? -';

            }
          
            if ( $app__populair_text.length > 200 ) {

              $app__populair_text = $app__populair_text.substring( 0, 200 );

            }
            
            var $app__populair_tooltip = '';
            
            if ( $app__settings[ 'local' ][ 'debug' ] === true ) {

              $app__populair_tooltip = ' title="' + ( $( 'li[data-guid=' + $app__value.key + '] h3' ).is( ':visible' ) ? '[new] ' : '[archived] ' ) + $app__populair_guid + '"';
    
            }

          $app__populair_html += (

            '<li class="cursor-pointer" data-scroll-to data-populair-guid="' + $app__populair_guid + '"' + $app__populair_tooltip + '>' +
            '<h5>' + $app__populair_title + '</h5>' +
            '<p><b class="mention"><i class="zmdi zmdi-hc-lg zmdi-comments mr-2"></i>' + $app__populair_comments + '</b>' + $app__populair_text + '</p>' +
            '</li>'

          );

        }
      
      } );
    
    }
    
    if ( $app__populair_html !== '' ) {

      $app__populair =  '<ul id="app__source_populair" class="list-unstyled"><li id="articles_populair"><article>';
      $app__populair += '<ol class="list-unstyled">' + $app__populair_html + '</ol>';
      $app__populair += '</article></li></ul>';

      $( '#app__overview #overview-articles' ).html( $app__populair );

    }

    $app__populair_data = [];
    $app__populair_html = '';

    app__overview_parse();

  } catch( $app__error ) {

    app__error( 'app__overview#05', 14, $app__error );

  }

}

/* ######################################################
  06. Fire the overview actions
###################################################### */

function app__overview_parse() {

  $( 'body' ).on( 'click', '#app__overview ol li[data-scroll-to], #app__personal ol li[data-scroll-to]', function( $app__event ) {

    try {

      $app__event.preventDefault();

/* Define the parent to scroll to */

      var $app__scroll_to = $( 'li[data-guid=' + ( $( this ).data( 'recent-guid' ) ? $( this ).data( 'recent-guid' ) : $( this ).data( 'populair-guid' ) ) + '] h3' );

/* Check if parent must trigger a comment [callback action] */

      $app__comment_callback = $( this ).data( 'recent-id' ) ? $( this ).data( 'recent-id' ) : -1;

/* Check if recent comment is already loaded */
      
      if ( $app__comment_callback !== -1 ) {
        
        $app__scroll_delay_callback = -1; /* Always jump to comment, don't scroll */

        var $app__comment_callback_el = $( 'h4[data-id="' + $app__comment_callback + '"]' );

        if ( $app__comment_callback_el.length ) {

          // $app__scroll_delay_callback = -1; /* Only jump to comment when loaded, otherwise scroll */

/* Comment is loaded, but article is collapsed */

          if ( !$app__comment_callback_el.is( ':visible' ) && $app__scroll_to.hasClass( 'collapsed' ) ) {

            $app__scroll_to.trigger( 'click' );

          }

/* Comment is loaded and not collapsed [anymore] */

          setTimeout( function() {

            app__overview_recent_show();
      
          }, $app__scroll_delay );

/* Skip the routine - comment is shown already */

          return;

        }

      }

      if ( $app__scroll_to.length ) {

/* Open any archived entry */

        if ( !$app__scroll_to.is( ':visible' ) ) {

          $app__archive_delay = 0; /* Skip fade-out animation */
          $app__scroll_to.closest( 'li[data-guid]' ).prevAll( 'li.archive' ).find( '[data-action=archive]' ).trigger( 'click' );

        }

        setTimeout( function() {

          window.scrollTo( 0, $app__scroll_to.offset().top - $( '.navbar' ).outerHeight() - 15 );

          setTimeout( function() {

/* Straight jump to newsitem or comment */

            if ( $app__comment_callback === -1 ) {

              $app__scroll_to.removeClass( 'animate_pulse' ).addClass( 'animate_pulse' );

              if ( $app__scroll_to.hasClass( 'collapsed' ) ) {

                $app__scroll_to.trigger( 'click' );
  
              }

/* Jump to comment | reaction when it's not already loaded > callback action */

            } else {

              if ( $app__scroll_to.hasClass( 'collapsed' ) ) {

                $app__scroll_to.trigger( 'click' );
  
              }

              setTimeout( function() {
  
                $app__scroll_to.parent().find( '[data-action=comments]' ).trigger( 'click' );
          
              }, $app__scroll_delay );
  
            }
    
            setTimeout( function() {

              $app__scroll_to.removeClass( 'animate_pulse' );
        
            }, 5000 );
        
          }, $app__scroll_delay );

        }, $app__scroll_delay );

      }

    } catch( $app__error ) {

      app__error( 'app__overview#06', 14, $app__error );

    }

  });

};

/* ######################################################
  07. Jump to a specific, most recent comment
###################################################### */

window.app__overview_recent_show = function app__overview_recent_show() {

  try {

    var $app__scroll_to = $( 'h4[data-id="' + $app__comment_callback + '"]' ).parent();

    app__comments_scroll( $app__scroll_to );

    setTimeout( function() {
  
      $app__comment_callback = -1;

    }, $app__scroll_delay );

  } catch( $app__error ) {

    app__error( 'app__overview#07', 14, $app__error );

  }

}

/* ######################################################
  08. Render thumbnails for each entry
###################################################### */

function app__overview_thumbnails() {

  try {

    $( '#app__overview [id^=overview-] [id^=app__source_] li ol li' ).each( function() {

/* Get populair- or recent-guid from child */

      $app__overview_thumbnail_el = typeof $( this ).data( 'populair-guid' ) !== 'undefined' ? $( this ).data(  ) : $( this ).data( 'recent-guid' );

/* Check if parent-element exists */

      $app__overview_thumbnail_el = $( 'li[data-guid=' + $app__overview_thumbnail_el + ']' );
      
      if ( $app__overview_thumbnail_el.length ) {

/* Try to fetch thumbnail-information from the parent */

        $( 'footer' ).prepend( app__thumbnail_get( $app__overview_thumbnail_el ) + '<br>' );

/* Set thumbnail on child */

      }
    
    });

  } catch( $app__error ) {

    app__error( 'app__overview#08', 14, $app__error );

  }

}

/* -----------------------------------------------------
  Catch me if you can
----------------------------------------------------- */

  app__cmd( 'app__overview : script loaded' );

} catch ( $app__error ) {

  app__error( 'app__overview#00', 14, $app__error.message );

} }( jQuery ));