/* ======================================================

T.O.C. [table of contents]

01. Fetch the settings
02. Render the vote | results
03. Show the results
04. Vote

====================================================== */

var $app__poll_id = -1;

;(function ( $ ) { try {

/* ######################################################
  01. Fetch the poll settings
###################################################### */

window.app__poll_fetch = function app__poll_fetch() {

  try {

    if ( $app__news.hasOwnProperty( 'poll' ) ) {

      var $app__poll_publish = $app__news[ 'poll' ][ 0 ][ 'meta' ][ 'publish' ];

      if ( $app__poll_publish !== -1 ) {

        $app__poll_id = $app__news[ 'poll' ][ 0 ][ 'meta' ][ 'id' ];
        app__poll_parse_data( $app__poll_id );

      } else {

        $( '#app__poll' ).removeClass( 'fired' ).html( '' );

      }

    }

  } catch( $app__error ) {

    app__error( 'app__poll#01', 13, $app__error );

  }

}

/* ######################################################
  02. Render the poll screens
###################################################### */

window.app__poll_parse_data = function app__poll_parse_data( $app__poll_id ) {

  try {

    var $app__poll_comments = $app__news[ 'poll' ][ 0 ][ 'meta' ][ 'comments' ];
    var $app__poll_title = app__format_string( $app__news[ 'poll' ][ 0 ][ 'meta' ][ 'title' ], 1 );
    var $app__poll_question = $app__news[ 'poll' ][ 0 ][ 'data' ][ 'question' ];
    var $app__poll_answers = $app__news[ 'poll' ][ 0 ][ 'data' ][ 'answers' ];
    var $app__poll = $app__poll_comments_icon = '';
    
    $app__poll_comments_button = '<button type="button" class="btn btn-secondary btn-brand border-0 mb-4" data-action="comment">' + $app__text[ 'string' ][ 13 ] + '</button>';
    
      if ( $app__poll_comments > 0 ) {
        
        $app__poll_comments_button = '<button type="button" class="btn btn-secondary btn-brand border-0 mb-4" data-action="comments">' + $app__text[ 'string' ][ 5 ] + '</button>';
        $app__poll_comments_icon = '<i class="zmdi zmdi-comment text-muted text-brand position-relative d-inline-block mr-2"><b class="text-light position-absolute">' + $app__poll_comments + '</b></i>';
      
      }

/* Poll wrapper // start */

    $app__poll += '<div class="app__poll"><ol class="list-unstyled mt-4 mb-2" id="app__source_poll" data-src="' + $app__poll_id + '"><li data-guid="poll" class="image">';
    $app__poll += '<section id="poll__meta" class="mb-2">';
    $app__poll += '<h4 class="bg-brand text-uppercase font-weight-bold text-center py-2 mb-3 shadow title-secondary"><b>' + $app__poll_title + '</b></h4>';
    $app__poll += '<h3 class="cursor-pointer collapsed pb-3 mb-0" data-toggle="collapse" data-target=".poll-collapse"><figure data-thumbnail="app/images/app.png" class="position-absolute rounded thumbnail border bg-light loading"></figure>' + $app__poll_comments_icon + $app__poll_question + '</h3>';
    $app__poll += '</section>';

/* Vote screen */

    $app__poll += '<section id="poll__votes"><div>';

    if ( $app__settings[ 'user' ][ 'poll' ] != $app__poll_id ) {

      $app__poll += '<article class="pb-4"><ul class="list-unstyled">';

        for ( var $app__i = 0; $app__i < $app__poll_answers.length; $app__i++ ) {

          $app__poll += (

            '<li class="border-bottom cursor-pointer font-weight-bold" data-vote="' + ( $app__i + 1 ) + '">' +
            '<i class="zmdi zmdi-hc-lg zmdi-hc-fw zmdi-chevron-right text-secondary mx-2"></i>' + $app__poll_answers[ $app__i ][ 1 ] +
            '</li>'

          );

        }

      $app__poll += '<li class="text-secondary">' + $app__text[ 'string' ][ 53 ] + '</li>';              
      $app__poll += '</ul></article>';

    }

    $app__poll += '</div></section>';

/* Results screen */

    $app__poll += '<section id="poll__results"><div>';
    $app__poll += '<article class="pb-4"><div class="article"><ul class="list-unstyled font-weight-bold">';

      for ( var $app__i = 0; $app__i < $app__poll_answers.length; $app__i++ ) {

        $app__poll += (

          '<li class="position-relative mb-2 w-100">' +
          '<div class="bg-brand-light pt-1" style="width:' + $app__poll_answers[ $app__i ][ 0 ] + '%;"><span>&nbsp;</span></div>' +
          '<span>' + $app__poll_answers[ $app__i ][ 1 ] + '</span>' +
          '<span>' + $app__poll_answers[ $app__i ][ 0 ] + '%</span>' +
          '</li>'

        );

      }

    $app__poll += '</ul></div>';
    $app__poll += '</article>';
    $app__poll += $app__poll_comments_button;
    $app__poll += '<button type="button" class="btn btn-dark btn-brand-dark border-0 mb-4 float-right" data-action="close">' + $app__text[ 'string' ][ 54 ] + '</button>';
    $app__poll += '</div></section>';

/* Poll wrapper // end */

    $app__poll += '</li></ol></div>';

    $( '#app__poll' ).html( $app__poll ).addClass( 'fired' );

/* Make voting and results same height */

    var $app__poll_height = Math.max( $( '#poll__votes > div' ).height(),  $( '#poll__results > div' ).height() );

    $( '#poll__votes > div, #poll__results > div' ).css( {

      'min-height': $app__poll_height + 'px'

    } );

    $( '#poll__votes' ).addClass( 'collapse poll-collapse' );
    $( '#poll__results' ).addClass( 'd-none' );
  
/* Show results, when needed */

      if ( $app__settings[ 'user' ][ 'poll' ] == $app__poll_id ) {

        app__poll_show_results( 0 );

      }

    $app__poll = '';

  } catch( $app__error ) {

    app__error( 'app__poll#02', 13, $app__error );

  }

}

/* ######################################################
  03. Show the poll results
###################################################### */

window.app__poll_show_results = function app__poll_show_results( $app__fade ) {

  try {

    $( '#poll__votes' ).fadeOut( $app__fade, function() {

      $( this ).remove();
      $( '#poll__results' ).removeClass( 'd-none' ).addClass( 'collapse poll-collapse' + ( $app__fade > 0 ? ' show' : '' ) ).find( 'ul' ).fadeOut ( 0 ).fadeIn( $app__fade );

    } )

  } catch( $app__error ) {

    app__error( 'app__poll#03', 13, $app__error );

  }

}

/* ######################################################
  04. Fire the vote buttons
###################################################### */

$( 'body' ).on( 'click', '#poll__votes:not(.disabled) [data-vote]', function( $app__event ) {

  try {

    $app__event.preventDefault();
    
    $( '#poll__votes' ).addClass( 'disabled' );
    
    var $app__poll = $( '#app__source_poll' ).data( 'src' );
    var $app__vote = $( this ).data( 'vote' );

    var $app__api = 'poll';
    $app__url = $app__settings[ 'local' ][ 'api' ] + $app__api + '&poll=' + $app__poll + '&vote=' + $app__vote;

    app__cmd( 'app__poll : vote > ' + $app__url );

    var $app__data = app__data();

    $.ajax({

      method: 'post',
      url: $app__url,
      cache: false,
      dataType: 'text',
      data: $app__data,
      complete: function() {

/* 2DO */

      },
      success: function( $app__response, $app__status, $app__xhr ) {

        if ( $app__response == '200' ) {
          
          app__user_set( 'poll', '' + $app__poll );
          app__poll_show_results( 750 );

        } else {

          $( '#poll__votes' ).removeClass( 'disabled' ).html( $app__response );

        }

        app__cmd( 'app__poll : voted', 1 );

      },
      error: function( $app__xhr, $app__status, $app__error ) {

        app__error( 'app__poll#04', 5, JSON.stringify( $app__xhr ) );

      }

    });

  } catch ( $app__error ) {

    app__error( 'app__poll#05', 13, $app__error );

  }

});

/* -----------------------------------------------------
  Catch me if you can
----------------------------------------------------- */

  app__cmd( 'app__poll : script loaded' );

} catch ( $app__error ) {

  app__error( 'app__poll#00', 13, $app__error.message );

} }( jQuery ));