/* ======================================================

  T.O.C. [table of contents]

  01. Scroll listener
  02. Scrollbar
  03. Back2top

====================================================== */

;(function ( $ ) { try {

/* ######################################################
  01. Universal scroll behaviour [throttled]
###################################################### */

var $app__scroll_wait = false;
var $app__scroll_speed = 500;
var $app__scroll_throttle = 250; /* Throttle | debounce in .ms */

$( window ).on( 'scroll resize', function () {

  if ( $app__scroll_wait == false ) {

/* Disable scroll of the body on mobile [Android] devices */

    if ( ( $( '.modal-open' ).length || $( '.menu-open' ).length ) && !$( '.app__ua_w10m' ).length ) {

      $( 'html, body' ).animate( {
        
        scrollTop: $app__scroll_pos
      
      }, $app__scroll_speed );

    }

    $app__scroll_wait = setTimeout( function () {

      $app__scroll_wait = false;

      app__scrollbar();
      app__back2top();

    }, $app__scroll_throttle );

  }

});

/* ######################################################
  02. Scrollbar
###################################################### */

var $app__scrollbar = $( '#scrollbar' );
var $app__scroll_visible = false;
var $app__scroll_value_bar = $app__scroll_value_bar_old = 0;

/* Show | update the scrollbar */

window.app__scrollbar = function app__scrollbar() {

  $app__scrollbar.show();

  var $app__scrolled = $( document ).scrollTop(),
      $app__height_page = $( document ).height(),
      $app__height_screen = $( window ).height(),
      $app__height_window = $app__height_page - $app__height_screen;

  $app__scroll_value_bar = Math.round( $app__scrolled / ( $app__height_window / 100 ) );

  $app__scrollbar.css( {

    top: ( ( $app__height_screen / 100 ) * $app__scroll_value_bar ) - ( $app__scrollbar.height() / 2 )

  });

/* Check if scrollbar must be hidden */

  if ( !$app__scroll_visible ) {

    $app__scroll_visible = true;
    $app__scroll_check = setInterval( app__scrollbar_hide, 1000 );

  }

}

/* Hide the scrollbar */

function app__scrollbar_hide() {

  if ( $app__scroll_value_bar == $app__scroll_value_bar_old ) {

    clearInterval( $app__scroll_check );

    $app__scrollbar.fadeOut( 1000 );
    $app__scroll_visible = false;

  }

  $app__scroll_value_bar_old = $app__scroll_value_bar;

}

/* ######################################################
  03. Create a back2top button
###################################################### */

var $app__scroll_value_top = $app__scroll_value_top_old = 0;
var $app__scroll_offset = 100;

window.app__back2top = function app__back2top() {

  $app__scroll_value_top = $(window).scrollTop();

  if ( $app__scroll_value_top > $app__scroll_offset ) {

    $( '#back2top' ).addClass( 'visible' );

  } else {

    $( '#back2top' ).removeClass( 'visible' );

  }

/* Check if scroll-intention is going down, or up */

  if ( $app__scroll_value_top > $app__scroll_value_top_old ) {

    $( '#back2top' ).removeClass( 'nav-up' ).addClass( 'nav-down' );

  }

  if ( $app__scroll_value_top <= $app__scroll_value_top_old || $(window).scrollTop() == $(document).height() - $(window).height()) {

    $( '#back2top' ).removeClass( 'nav-down' ).addClass( 'nav-up' );

  }

  $app__scroll_value_top_old = $app__scroll_value_top;

  if ( $(window).scrollTop() == 0 ) {

    $( '#back2top' ).removeClass( 'nav-down nav-up' );

  }

}

/* Fire the button */

$( '#back2top' ).on( 'click', function() {

  if ( $( this ).hasClass( 'nav-up' ) ) {

    $( 'html, body' ).animate( {

      scrollTop: 0

    }, $app__scroll_speed );

  } else {

    $( 'html, body' ).animate( {

      scrollTop: $( document ).height() - $app__win_h

    }, $app__scroll_speed );

  }

});

/* -----------------------------------------------------
  Catch me if you can
----------------------------------------------------- */

  app__cmd( 'app__scroll : script loaded' );

} catch ( $app__error ) {

  app__error( 'app__scroll#00', 4, $app__error.message );

} }( jQuery ));