/* ======================================================

  T.O.C. [table of contents]

  01. Fallback analytics
  02. Default analytics
  03. Extended analytics

====================================================== */

var _paq = _paq || [];

;(function ( $ ) { try {

/* ######################################################
  01. Load fallback-script when default fails
###################################################### */

window.app__stats_fallback = function app__stats_fallback() {

  if ( $app__settings[ 'local' ][ 'url-count' ] !== -1 ) {

    try {

      setTimeout( function() {

        var $app__cache = Date.now();

        $( 'img#app__stats' ).attr( 'src', $app__settings[ 'local' ][ 'url-count' ] + 'piwik.php?timestamp=' + $app__cache + 
          '&idsite=' + parseInt( $app__settings[ 'local' ][ 'id' ] ) +
          '&rec=1&action_name=' + encodeURI( app__format_string( $app__text[ 'string' ][ 0 ] )  ) + '__pixel');

        app__cmd( 'app__stats : fallback', 1 );
    
      }, 10000 );
    
    } catch ( $app__error ) {

//  app__error( 'app__stats#01', 11, $app__error.message );

    }

  }

}

if ( $app__settings[ 'local' ][ 'url-count' ] !== -1 ) {

/* ######################################################
  02. Count every new session
###################################################### */

  try {

      _paq.push( [ 'setDocumentTitle', app__format_string( $app__text[ 'string' ][ 0 ] ) ] );
      _paq.push( [ 'trackPageView' ] );
      _paq.push( [ 'setTrackerUrl', $app__settings[ 'local' ][ 'url-count' ] + 'piwik.php']);
      _paq.push( [ 'setSiteId', parseInt( $app__settings[ 'local' ][ 'id' ] ) ] );

    } catch ( $app__error ) {

//  app__error( 'app__stats#02', 11, $app__error.message );
      
    }

/* ######################################################
  03. Stats based on source and content
###################################################### */

  $( 'body' ).on( 'click', '[data-action=open]', function() {

    try {

      var $app__article_link = $( this ).closest( 'li' ).data( 'link' );
      var $app__article_subject = app__format_string ( $( this ).closest( 'li' ).find( 'h3' ).html(), 3 );
      var $app__article_src = parseInt ( $( this ).closest( 'ol' ).data( 'src' ) );

/* Add entry to database */

      _paq.push( [ 'setDocumentTitle', $app__article_subject ] );
      _paq.push( [ 'setCustomUrl', $app__article_link ] );
      _paq.push( [ 'trackPageView' ] );
      _paq.push( [ 'trackLink', $app__article_link, 'link' ] );
      _paq.push( [ 'trackEvent', $app__article_src, 'Open', $app__article_subject ] );

      app__cmd( 'app__stats : ' + $app__article_src + ' > ' + $app__article_subject + '\n####### ' + $app__article_link, 1 );

    } catch ( $app__error ) {

//  app__error( 'app__stats#03', 11, $app__error.message );
        
    }

  } );

}

/* -----------------------------------------------------
  Catch me if you can
----------------------------------------------------- */

app__cmd( 'app__stats : script loaded' );

} catch ( $app__error ) {

//  app__error( 'app__stats#00', 11, $app__error.message );

} }( jQuery ));