/* ======================================================

  T.O.C. [table of contents]

  01. Get a user setting
  02. Set a user setting
  03. Get a list entry
  04. Set a list entry
  05. Get all storage data

====================================================== */

/* 

  localStorage.clear();
  localStorage.removeItem( 'app__01__user_pin' );

*/

var $app__storage = window.localStorage || ( window.globalStorage ? globalStorage[ location.hostname ] : null );

;(function ( $ ) { try {

/* ######################################################
  01. Get a specific user setting
###################################################### */

window.app__user_get = function app__user_get( $app__storage_key, $app__storage_val ) {

  try {

    var $app__storage_val = $app__storage_val || '';

    if ( $app__storage[ 'app__' + $app__settings[ 'local' ][ 'id' ] + '__user_' + $app__storage_key ] !== undefined &&
         $app__storage[ 'app__' + $app__settings[ 'local' ][ 'id' ] + '__user_' + $app__storage_key ] !== null ) {

      $app__settings[ 'user' ][ $app__storage_key ] = $app__storage_val = $app__storage['app__' + $app__settings[ 'local' ][ 'id' ] + '__user_' + $app__storage_key ];

      app__cmd( 'app__storage : user [GET] > ' + $app__storage_key + ' => ' + ( $app__storage_val == '' ? '(empty)' : $app__storage_val ) );

    } else {

      app__user_set( $app__storage_key, $app__storage_val );

    }

    return $app__storage_val;

  } catch( $app__error ) {

    app__error( 'app__storage#01', 9, $app__error );

  }

}

/* ######################################################
  02. Set | save | update an user setting
###################################################### */

window.app__user_set = function app__user_set( $app__storage_key, $app__storage_val ) {

  try {

    var $app__storage_val = $app__storage_val || '';

    $app__storage[ 'app__' + $app__settings[ 'local' ][ 'id' ] + '__user_' + $app__storage_key ] =
    $app__settings[ 'user' ][ $app__storage_key ] =
    $app__storage_val;

    app__cmd( 'app__storage : user [SET] > ' + $app__storage_key + ' => ' + ( $app__storage_val == '' ? '(empty)' : $app__storage_val ) );

  } catch( $app__error ) {

    app__error( 'app__storage#02', 9, $app__error );

  }

}

/* ######################################################
  03. Get the contents of a specific list
###################################################### */

window.app__list_get = function app__list_get( $app__storage_key, $app__storage_val ) {

  try {

    var $app__storage_val = $app__storage_val || [];

    if ( $app__storage[ 'app__' + $app__settings[ 'local' ][ 'id' ] + '__list_' + $app__storage_key ] !== undefined &&
         $app__storage[ 'app__' + $app__settings[ 'local' ][ 'id' ] + '__list_' + $app__storage_key ] !== null ) {

      $app__settings[ 'list' ][ $app__storage_key ] = $app__storage['app__' + $app__settings[ 'local' ][ 'id' ] + '__list_' + $app__storage_key ].split( ',' );

    } else {

      $app__storage[ 'app__' + $app__settings[ 'local' ][ 'id' ] + '__list_' + $app__storage_key ] =
      $app__settings[ 'list' ][ $app__storage_key ] = $app__storage_val;

    }

  } catch( $app__error ) {

    app__error( 'app__storage#03', 9, $app__error );

  }

}

/* ######################################################
  04. Set | save | update a list entry
###################################################### */

window.app__list_set = function app__list_set( $app__storage_key, $app__storage_val ) {

  try {

    var $app__storage_val = $app__storage_val || false;

    if ( $app__storage_val !== false ) {

      if ( $.inArray( $app__storage_val, $app__settings[ 'list' ][ $app__storage_key ] ) == -1 && $app__storage_val != '' ) {

        $app__settings[ 'list' ][ $app__storage_key ].reverse();
        $app__settings[ 'list' ][ $app__storage_key ].push( $app__storage_val );
        $app__settings[ 'list' ][ $app__storage_key ].reverse();

/* Remove keys with different values */

        if ( $app__storage_val.indexOf( '|' ) > 0 ) {

          var $app__list_temp = $app__settings[ 'list' ][ $app__storage_key ];
          var $app__list_keys = [];

          $app__settings[ 'list' ][ $app__storage_key ] = [];

/* Itterate through the temporary array, push value to (cleaned) list when it's a new entry */

            for ( var $app__i = 0; $app__i < $app__list_temp.length; $app__i++ ) {

              var $app__list_val = $app__list_temp[ $app__i ].substr( 0, $app__list_temp[ $app__i ].indexOf( '|' ) );

              if ( $app__list_keys.indexOf( $app__list_val ) < 0 ) {

                $app__list_keys.push( $app__list_val );
                $app__settings[ 'list' ][ $app__storage_key ].push( $app__list_temp[ $app__i ] );

              }

            }

        }

/* Remove any empty value */

        $app__settings[ 'list' ][ $app__storage_key ] = $.grep( $app__settings[ 'list' ][ $app__storage_key ], function( $app__entry ) {

          return $app__entry == 1 || $app__entry

        } );

/* Remove entries above maximum allowed length */

        $app__settings[ 'list' ][ $app__storage_key ].splice( $app__settings[ 'local' ][ 'list' ], 1 );

/* Save | update the new list */

        $app__storage[ 'app__' + $app__settings[ 'local' ][ 'id' ] + '__list_' + $app__storage_key ] = $app__settings[ 'list' ][ $app__storage_key ];

      }

    }

    app__cmd( 'app__storage : list > ' + $app__storage_key + ' => ' + $app__storage_val, 1 );

  } catch( $app__error ) {

    app__error( 'app__storage#04', 9, $app__error );

  }

}

/* ######################################################
  05. Get all local settings [user and list]
###################################################### */

window.app__storage = function app__storage() {

  try {

/* Fetch the unique user #ID */

    app__user_get( 'id' );

/* Fetch the nickname */

    app__user_get( 'name' );
    app__user_get( 'pin', '-1' );

/* Get the nickname-change-number [prevent falsy entries] */

    app__user_get( 'namechange', $app__settings[ 'local' ][ 'namechange' ] );

      if ( $app__settings[ 'user' ][ 'namechange' ] > $app__settings[ 'local' ][ 'namechange' ] ) {

        app__user_set( 'namechange', '' + $app__settings[ 'local' ][ 'namechange' ] );

      }

/* Fetch the namecolor */

    app__user_get( 'color' );

/* Fetch the most recent app-version */

    app__user_get( 'version', '-1' );

/* Fetch the most recent seen message */

    app__user_get( 'message', '-1' );

/* Fetch the most recent seen interstitial */

    app__user_get( 'interstitial', '-1' );

/* Fetch the most recent voted poll */

    app__user_get( 'poll', '-1' );

/* Check which tooltip must be shown */

    app__user_get( 'tip', '1' );

/* Get the user-preference for dark mode (night theme) */

    app__user_get( 'dark_mode' );
    $( '#dark_mode' ).prop( 'checked', $app__settings[ 'user' ][ 'dark_mode' ] ).change();

/* Get the user-preference for the images */

    app__user_get( 'images_hide' );
    $( '#images_hide' ).prop( 'checked', $app__settings[ 'user' ][ 'images_hide' ] ).change();

/* Get the user-preference for the comments */

    app__user_get( 'comments_hide' );
    $( '#comments_hide' ).prop( 'checked', $app__settings[ 'user' ][ 'comments_hide' ] ).change();

/* Get the user-preference for overview */

//  app__user_get( 'overview_hide' );
//  $( '#overview_hide' ).prop( 'checked', $app__settings[ 'user' ][ 'overview_hide' ] ).change();

/* Get the user-preference for discussion-view */

    app__user_get( 'comments_order' );
    $( '#comments_order' ).prop( 'checked', $app__settings[ 'user' ][ 'comments_order' ] ).change();

/* Get the user-preference for fonts */

    app__user_get( 'fonts_serif' );
    $( '#fonts_serif' ).prop( 'checked', $app__settings[ 'user' ][ 'fonts_serif' ] ).change();

    app__user_get( 'fonts_small' );
    $( '#fonts_small' ).prop( 'checked', $app__settings[ 'user' ][ 'fonts_small' ] ).change();

    app__user_get( 'fonts_smaller' );
    $( '#fonts_smaller' ).prop( 'checked', $app__settings[ 'user' ][ 'fonts_smaller' ] ).change();

/* Done, fetching settings */

    app__cmd( '', 1 );
    app__cmd( 'app__storage : user-settings fetched\n   >    $app__settings[ \'user\' ];', 1 );

/* Build the history-lists */

    app__list_get( 'articles' );            /* articles read by user */
    app__list_get( 'comments' );            /* comments written by user */
    app__list_get( 'commented' );           /* articles that contain a comment from user */
    app__list_get( 'likes' );               /* likes given by user */
    app__list_get( 'hides' );               /* hides given by user */
    app__list_get( 'personal-bookmarks' );  /* saved article bookmarks */
    app__list_get( 'personal-comments' );   /* recent personal reactions */

    app__cmd( 'app__storage : storage-settings fetched\n   >    $app__settings[ \'list\' ];', 1 );

  } catch( $app__error ) {

    app__error( 'app__storage#05', 9, $app__error );

  }

}

/* -----------------------------------------------------
  Catch me if you can
----------------------------------------------------- */

  app__cmd( 'app__storage : script loaded' );

} catch ( $app__error ) {

  app__error( 'app__storage#00', 9, $app__error.message );

} }( jQuery ));